/******************************************************************************
														 Multi-Edit Macro File
															 01-May-97  14:48

  Function: Provides support for Dynamic dialog boxes

	$Header: /MEWIN32/SH/DIALOG.SH 23    3/11/98 2:25p Todd $

							 Copyright (C) 1997 by American Cybernectics, Inc.
 ****************************************************************************/
// Dialog control styles
#define dlg_Text          0  // Standard text prompt
#define dlg_Integer       1  // Integer prompt
#define dlg_RealNumber    2  // Real number prompt
#define dlg_Choice        3  // Pull down menu
#define dlg_Hex           4  // Hex Integer prompt
#define dlg_MacroBtnInt   7  // Integer prompt with button
#define dlg_MacroBtnStr   8  // Text prompt with button
#define dlg_Keycode       9  // Keycode prompt - for keymapping, etc.
#define dlg_Static       10  // Static text - mostly used for titles of other fields
#define dlg_PushButton   11  // Pushbutton - can run a macro or return a value
#define dlg_RadioButton  12  // Radio button. used in groups of 2 or more
#define dlg_CheckBox     13  // Check box.  On or off.
#define dlg_ListTextBox  15  // Multiple-choice list box.  see DLG_LISTBOX for a more versatile control
#define dlg_ViewTextBox  16  // Multi-line text editing window
#define dlg_HiddenStr    17  // Hidden text prompt - for passwords, etc.
#define dlg_HiddenInt    18  // Like above, except for integers
#define dlg_GroupBox     21  // Box around groups of related items
#define dlg_BlackFrame   22  // Black outline frame
#define dlg_GreyFrame    23  // Grey outline frame
#define dlg_WhiteFrame   24  // White outline frame
#define dlg_ListBox      25  // ListBox as DLG_ListTextBox but much more powerful
//  /INSWCMD=x    The command to send when
//                the ins key is presssed
//  /DELWCMD=x    The command to send when
//                the del key is pressed

#define dlg_BlackRect    26 //
#define dlg_GreyRect     27
#define dlg_WhiteRect    28

#define dlg_BitmapDefine 30
#define dlg_BitmapStatic 31
#define dlg_BitmapBtn    32
#define dlg_Icon         33
#define dlg_3State       34
#define dlg_OwnerButton  35
#define dlg_DirButton    36
#define dlg_SelectColor  37             // Popup a color selector dialog

#define dlg_SubDlg       50             // /TC=TabControlId
                                        // /TN=TabNum
                                        // /BM=BuildMacro
                                        //        /M=1  init
                                        //           2  end
                                        //        /DLG=dlghandle

#define dlg_TabBar			 52
#define dlg_TreeList     53             // Give a hierarchical tree view.


#define dlg_removed      -1             // Means that a given control has been deleted


#define dlg_PosOffset     0x00010000
#define dlg_NegOffset     0x00020000
#define dlg_Units         0x00040000

	// Edit control styles
	// Use for DLG_Text controls WITHOUT history lists.
	// These flags are ignored for DLG_Text controls with history lists
#define dlgf_es_Left        0x00000000
#define dlgf_es_Center      0x00010000
#define dlgf_es_Right       0x00020000
#define dlgf_es_MultiLine   0x00040000
#define dlgf_es_UpperCase   0x00080000
#define dlgf_es_LowerCase   0x00100000
#define dlgf_es_Password    0x00200000
#define dlgf_es_AutoVScroll 0x00400000
#define dlgf_es_AutoHScroll 0x00800000
#define dlgf_es_NoHideSel   0x01000000
#define dlgf_es_OEMConvert  0x04000000
#define dlgf_es_ReadOnly    0x08000000
#define dlgf_es_WantReturn  0x10000000
#define dlgf_Es_HScrollBar  0x00000008

#define dlgf_GetTextFromWin 0x00000004  // This flag allows DLG_Text to get
																				// the text to and from a specified
																				// window.  The window is specified
																				// with /WID=window_id in the
																				// misc parameter in DlgAddCtrl
																				// This is usually used with
																				// DLGF_es_multiline.

// These can be used on the STATIC class
#define dlgf_ss_Left           0x000000
#define dlgf_ss_Center         0x010000
#define dlgf_ss_Right          0x020000
#define dlgf_ss_LeftNoWordWrap 0x0C0000
#define dlgf_ss_NoPrefix       0x800000   // Don't do "&" character translation
#define dlgf_ws_border


#define dlgf_Disable         0x00000001
#define dlgf_DefButton       0x00000002
#define dlgf_BitmapTgl       0x00010000
#define dlgf_TabbarOwnerDraw 0x00002000

#define dlgf_UseOldCtrl      0x00004000  // Look for a previous control that has been removed.  If empty, use it.

#define dlgf_lbIncSearch  	0x00010000
#define dlgf_lbPtr        	0x00080000
#define dlgf_lb_ScrollBar 	0x00100000	// Use this to force a scrollbar in a listbox
#define dlgf_lb_ExtendedSel 0x00200000 // Allow multiple selections
#define dlgf_lb_HScroll   	0x00400000
#define dlgf_lb_NoDblClick 	0x00800000 // No double click on the list items

#ifndef dlg_NoSize
	#define dlg_NoSize        0x00000001
	#define dlg_NoCenter      0x00000002
	#define dlg_ScreenCenter  0x00000004
	#define dlg_NoParDisable  0x00000008
	#define dlg_Template      0x00000010
	#define dlg_Modeless      0x00010000
	#define dlg_TabSubDlg			0x00020000
  #define dlg_NoShow        0x00040000
#endif

  #define dlg_MaximizeBtn   0x00080000
#define Dlg_Wcmd_Init    0x7fff

#define dlg_Units_Per_Row   8
#define dlg_Units_Per_Line  12
#define dlg_Units_Per_Col   4
#define dlg_Units_Line_Half 18
#define dlg_Units_Hline     6
#define dlg_UNITS_QLine     3

#define dlg_DefBtnHeight    13
#define dlg_StanBtnWidth    10

#define wm_Trigger_Popup ( wm_User + 200 )
#define wm_Get_SpinWin   ( wm_User + 201 )

#define sk_NoDelete					0x0001
#define sk_NoCurrentAssign  0x0002


// MEWButton's class-specific window styles.
#define MEWBTN_SIZETOBUTTON         0x0001    // default
#define MEWBTN_PUSHBUTTON           0x0002
#define MEWBTN_DEFPUSHBUTTON        0x0004


#define MEWBTN_TOGGLEBUTTON         0x0008    // Can be combined with
																							// mewbtn_pushdbutton to create
																							// a button that can be turned
																							// ON or turned OFF.
																							// Allows the user to create a
																							// group of related buttons
																							// similar to the
																							// standard Windows checkboxes

#define MEWBTN_SIZETOBITMAP         0x0010

#define MEWBTN_TEXTBUTTON           0x0020    // (not available)
#define MEWBTN_TEXTANDBITMAP        0x0040    // combine text and bitmap

#define MEWBTN_ONESHOT              0x0080    // can be combined with
																							// mewbtn_pushbutton to create
																							// a button that can only be
																							// turned ON (via keyb/mouse).
																							// Note: 'owner' of the control
																							//  must reset the state using
																							//  SetStateOfMEWButton(
																							//     NORMAL_MEWBTN);
																							//  This allows the owner to
																							//  create a group of related
																							//  buttons similar to the
																							//  std Windows radio buttons

#define MEWBTN_STATICBUTTON         0x0100    // no border
#define MEWBTN_BORDEREDSTATICBUTTON 0x0200


																							// MEWButton color drawing styles
#define MBCS_BKCOLOR                0x1000    // (not available)
																							//   draw with color background
#define MBCS_TRANSPARENT            0x2000    // draw with transparent bkgrnd
																							// (given the color to mask out)
#define MBCS_DRAW                   0x0000    // draw as is



// MEWBTN_TEXTANDBITMAP orientation & alignment
#define MBT_TOP                     0x0001
#define MBT_BOTTOM                  0x0002
#define MBT_LEFT                    0x0003
#define MBT_RIGHT                   0x0000    // default

#define MBT_TEXTLEFT                0x0000    // default
#define MBT_TEXTCENTER              0x0010
#define MBT_TEXTRIGHT               0x0020


// MEWButton's states
// returned by GetStateOfMEWButton function
#define NORMAL_MEWBTN             0
#define SELECTED_MEWBTN           1
#define DISABLE_MEWBTN            2
#define FOCUS_MEWBTN              3
#define DEFAULT_MEWBTN            4

#define SHOT_MEWBTN               5   // OneShot button has been clicked
#define STUCK_MEWBTN              6   // Toggle button is in the ON state

#define STATIC_MEWBTN             7
#define MOUSEUPDOWN_MEWBTN        8


// MEWButton's class-specific window messages.
//
//
// NONE


// MEWButton's notification codes sent in HIWORD of lParam
// during a WM_COMMAND message.
// (mimic standard BN_ codes + more)
// Use the GetStateOfMEWButton() function to check the button's state
// if the style is ToggleButton or OneShot or PushButton
#define MEWBTN_LCLICKED					0


// MEWButton's creation type codes
#define MEWBTN_RT_RESNAME				0 	// (lpsz) resource name
#define MEWBTN_RT_RESID					1 	// (int ) resource identifier
#define MEWBTN_RT_BMPF					2 	// (lpsz) direct .bmp filename
#define MEWBTN_RT_RESFILENAME 	3 	// (lpsz) res file ^ res name
#define MEWBTN_RT_RESFILEID			4 	// (lpsz) res file % res id
#define MEWBTN_RT_BMHANDLE			5 	// (int ) handle to bitmap already loaded
#define MEWBTN_RT_WIN31OEM      6   // (int)  OEM Windows bitmap resource id





structure DlgCtrl {
	int 	CtrlType;
	int 	C, R, Cw, Ch;
	Int   ux, uy, uw, uh;
	Int   x, y, w, h;
	Int   Id;
	int 	Flags;
	int 	WHandle;
	int 	ExtraHandle;
	int   gh, gw;
	int   ExtraFlags;
}

structure TabDraw_Struct
{
    int select_bkcolor;
    int select_textcolor;
    int select_textfont;
    int select_flags;

    int bkcolor;
    int textcolor;
    int textfont;
    int flags;
}


prototype Dialog {
		// Creates and returns a dialog handle. This handle must be passed to
		// all dialog box functions
	int DlgCreate( int &dlg );

		// Creates a dialog control.
	int DlgAddCtrl( int dlg,    // the dialog handle create with DlgCreate
									int ctrltype,   // the control type
									str ctrltext,   // the control title
									int x,          // the x coordinate or column number
									int y,          // the y coordinate or row number
									int width,      // the width of the control
									int height,     // the height of the control
									int ctrlid,     // the identifying number for the control
									int flags,			// bit flags
									str misc        // miscelaneous parameters
							 );

		// Gets the X and Y coordinates of a control in dlg units
	void DlgGetXY( int dlg,
								 int ctrlid,
								 int &x,
								 int &y );

		// Gets the column and row coordinates of a control
	void DlgGetCR( int dlg,
								 int ctrlid,
								 int &c,
								 int &r );


		// Returns the integer value for a dialog control
	int DlgGetInt( int dlg,         // the dialog handle
								 int ctrlid       // the control id
							 );


		// Returns the string value for a dialog control
	str DlgGetStr( int dlg,         // the dialog handle
								 int ctrlid       // the control id
							 );

		//  Sets the integer value of the specified dialog control
  void  DlgSetInt( int dlg,       // the dialog handle
									int ctrlid,     // the control id
									int value       // the value to set
								);

		// Sets the string value of the specified dialog control
  void  DlgSetStr( int dlg,       // the dialog handle
									int ctrlid,     // the control id
									str value       // the value to set
								);

		// Deletes a dialog structure from memory
		// and then sets the dialog handle to zero
  void  DlgKill( int dlg );

		// Fits a filename into w (width).
  str   DlgFitFileName( str fn, int w  );

		// Copies all of the data from the Windows controls into the dialog ctrl
		// records.  This must only be done AFTER a DlgBuild.
  void  DlgSetFields( int dlg );

		// Executes the specified dialog box
  int   DlgExecute(  int dlg,       // the dialog box handle
									 int startid,			// the Default ctr id
									 str title,       // the title of the dialog
									 str helpindex,   // help file index
									 str misc,        // misc parameters
                                    // /RPOS=globalstr
                                    //     get/store dialog box position in
                                    //     named global string
									 int flags
								);

  int   DlgBuild( int dlg,
								str title,
								str helpindex,
								str misc,
								int flags
								);

  int   DlgMessageProc( int &retval, int window, message, wparam, lparam, str parms );

  int   GetDefaultButton( int w );
  int   SetDefaultButton( int w, int id );

  str   Set_Bitmap  ( str bitmap_str, int parent );
  str   Set_KeyCode ( str key_str, int parent, str title, int flags );

  int   DlgGetWhandle (int dlg);
  void  DlgGetStruct  (int dlg, m_int, struct DlgCtrl);
  void  DlgSetStruct(int dlg, m_int, struct DlgCtrl);
  int   DlgGetId      (int dlg, seq_num);
  int   DlgIdToSeq    (int dlg, id_int);

  void  DlgSetPos     ( int dlg, x, y);

  void  DlgUpdateCtrl (int dlg, ctrl_id, seq_int);
  void  DlgSetFocus   ( int Dlg, CtrlId );
/******************************************************************************
  Function: Set the input focus to CtrlId.
  Entry   : int Dlg				- The dialog data handle ( not the Windows handle )
						int CtrlId		- The control id number
  Exit    : None
********************************************************************( ldh )***/

	void DlgSetActiveWindow( int Dlg );
/******************************************************************************
  Function: Makes the dialog window for Dlg the active window.
  Entry   : int Dlg				- The dialog data handle ( not the Windows handle )
	Exit		: None
********************************************************************( ldh )***/

  void DlgEnableCtrl( int Dlg, int CtrlId, int Enable );
/******************************************************************************
  Function: Enables or Disables an existing dialog control for input.
  Entry   : int Dlg   		- The dialog data handle ( not the Windows handle )
						int CtrlId		- The control id number
						int Enable		- True to enable control, False to disable control.
  Exit    : None
********************************************************************( ldh )***/

  int DlgCtrlIsEnabled(int dlg, id_int);
/******************************************************************************
  Function: Used to determine if a control is active and can receive input
  Entry   : int Dlg				- The dialog data handle ( not the Windows handle )
						int CtrlId		- The control id number
  Exit    : int
							True				- Control is enabled
							False				- Contorl is not enabled
********************************************************************( ldh )***/

  void DlgInsertText(int Dlg, id_int, str t_str);

  void DlgGetCtrlPos( int Dlg, int CtrlId, int &X, int &Y );

  void DlgChoice2Win( int Dlg, int CtrlId );
/******************************************************************************
  Function: Puts all the choices in a dlg_Choice type control into the current
						MEW window

  Entry   : int Dlg				- The dialog data handle ( not the Windows handle )
						int CtrlId		- The control id number
  Exit    : None
********************************************************************( ldh )***/

  void DlgWin2Choice( int Dlg, int CtrlId );
/******************************************************************************
  Function: Updates a dlg_Choice type control from line of text in the current
						MEW window.

  Entry   : int Dlg				- The dialog data handle ( not the Windows handle )
						int CtrlId		- The control id number
  Exit    : None
********************************************************************( ldh )***/


  int   DlgGetHandle( int Dlg, int CtrlId );
/******************************************************************************
  Function: Return the Windows handle for CtrlId
  Entry   : int Dlg     - Data dialog handle
            int CtrlId  - Control Id

  Exit    : int         - The Windows handle for CtrlId
********************************************************************( ldh )***/
  void  DlgSaveRetStr  ( m );
  str   Double_Slashes (str t_str);

  int   DlgCreateBitmapStatic( int parent, str name, int x, int y, int id );
  void  DlgShowTabPanel( int window, tabwin, num, hide, str parms );
  int   DlgAddSubDlg( int dlg, str title, int id, int flags, str parms );
  int   DlgActivateTab( int dlg, tab_ctrl, tab_id);

  str   DlgGetSubDlgInfo( int Dlg, int Window, int Tab_Ctrl, int Tab_Id );
  int   DlgRemoveTab( int parentdlg, int tab_ctrl, int tab_id );
  int   DlgGetCurrentTabId( int tab_win );
  void DlgSetUpDownRange( int spinwin, minint, maxint );
}
