/******************************************************************************
														 Multi-Edit Macro File
															 13-Aug-97  14:14

	Function: Windows 32bit API Ddeml Interface
	Author  : Dan Hughes

	$Header: /MeWin32/SH/Ddeml.sh 1     8/14/97 3:08a Dan $

							 Copyright (C) 1997 by American Cybernectics, Inc.
 *******************************************************************( ldh )***/

#define	HConvList 	int
#define HConv 			int
#define HSz 				int
#define HDdeData 		int

// the following structure is for use with xtyp_WildConnect processing.
#define 	PHSzPair 		Pointer
structure	THSzPair {
	HSz Service;
  HSz Topic;
}

// The following structure is used by DdeConnect( ) and DdeConnectList( )
// and by xtyp_Connect and xtyp_WildConnect callbacks.

#define 	PConvContext 	Pointer
structure TConvContext {
  int		cb;            								// set to sizeof(ConvCOnTEXT)
  int 	wFlags;        								// none currently defined.
  int 	wCountryID;    								// country code for topic/item strings used.
  int 	iCodePage;  									// codepage used for topic/item strings.
  int		dwLangID;     								// language ID for topic/item strings.
  int		dwSecurity;   								// Private security code.
	//  qos: TSecurityQualityOfService;		// used to support client impersonation
	int		Length;
  Byte	ImpersonationLevel;
  Byte  ContextTrackingMode;
  Byte	EffectiveOnly;
}

// The following structure is used by DdeQueryConvInfo( ):

#define 	PConvInfo 	Pointer
structure	TConvInfo {
	int	cb;            					// sizeof(CONVINFO)
  int	hUser;         					// user specified field
  int	hConvPartner;   				// hConv on other end or 0 if non-ddemgr partner
  int	hszSvcPartner;					// app name of partner if obtainable
  int	hszServiceReq;  				// AppName requested for connection
  int	hszTopic;  							// Topic name for conversation
  int	hszItem;   							// transaction item name or NULL if quiescent
  int	wFmt;           				// transaction format or NULL if quiescent
  int	wType;          				// XTYP_ for current transaction
  int	wStatus;        				// ST_ constant for current conversation
  int	wConvst;        				// XST_ constant for current transaction
  int	wLastError;     				// last transaction error.
  int	ConvList; 							// parent hConvList if this conversation is in a list
	//  TConvContext	ConvCtxt;   	// conversation context
  int	ccb;           					// set to sizeof(ConvCOnTEXT)
  int wFlags;        					// none currently defined.
  int wCountryID;    					// country code for topic/item strings used.
  int iCodePage;  						// codepage used for topic/item strings.
  int	dwLangID;     					// language ID for topic/item strings.
  int	dwSecurity;   					// Private security code.
	//  qos: TSecurityQualityOfService;		// used to support client impersonation
	int		Length;
  Byte	ImpersonationLevel;
  Byte  ContextTrackingMode;
  Byte	EffectiveOnly;

  int	Wnd;            				// window handle for this conversation
  int	Partner;      					// partner window handle for this conversation
}

// conversation states (usState)

#define  xst_Null 						0					// quiescent states
#define  xst_Incomplete				1
#define  xst_Connected 				2
#define  xst_Init1 						3         // mid-initiation states
#define  xst_Init2 						4
#define  xst_Reqsent 					5         // active conversation states
#define  xst_DataRcvd 				6
#define  xst_PokeSent 				7
#define  xst_PokeAckRcvd 			8
#define  xst_ExecSent 				9
#define  xst_ExecAckRcvd 			10
#define  xst_AdvSent 					11
#define  xst_UnadvSent 				12
#define  xst_AdvAckRcvd 			13
#define  xst_UnadvAckRcvd 		14
#define  xst_AdvDataSent 			15
#define  xst_AdvDataAckRcvd		16

// used in LOWORD(dwData1) of xtyp_AdvReq callbacks...

#define  cadv_LateAck 	0xFFFF

// conversation status bits (fsStatus)

#define  st_Connected 		0x0001
#define  st_Advise 				0x0002
#define  st_IsLocal 			0x0004
#define  st_Blocked 			0x0008
#define  st_Client 				0x0010
#define  st_Terminated		0x0020
#define  st_InList 				0x0040
#define  st_BlockNext 		0x0080
#define  st_IsSelf 				0x0100

// DDE constants for wStatus field

#define  dde_FAck 					0x8000
#define  dde_FBusy 					0x4000
#define  dde_FDeferUpd 			0x4000
#define  dde_fAckReq 				0x8000
#define  dde_FRelease 			0x2000
#define  dde_FRequested 		0x1000
#define  dde_FAppStatus 		0x00ff
#define  dde_FNotProcessed	0x0000

#define  dde_FAckReserved 	0x3ff0
#define  dde_FAdvReserved 	0x3fff
#define  dde_FDatReserved 	0x4fff
#define  dde_FPokReserved 	0xdfff

// message filter hook types

#define  msgf_DdeMgr			0x8001

// default codepage for windows & old DDE convs.

#define	 cp_WinAnsi 			1004
#define  cp_WinUnicode 		1200

#define	 cp_WinNeutral		cp_WinAnsi

// transaction types

#define  xtypf_NoBlock 				0x0002    // CBR_BLOCK will not work
#define  xtypf_NoData 				0x0004  	// DDE_FDEFERUPD
#define  xTypf_AckReq 				0x0008  	// DDE_FACKREQ

#define  xclass_Mask 					0xFC00
#define  xclass_Bool 					0x1000
#define  xclass_Data 					0x2000
#define  xclass_Flags 				0x4000
#define  xclass_Notification	0x8000

#define  xtyp_Error 					( 0x0000 | xclass_Notification or xtypf_NoBlock )
#define  xtyp_Advdata 				( 0x0010 | xclass_Flags )
#define  xtyp_Advreq 					( 0x0020 | xclass_Data or xtypf_NoBlock )
#define  xtyp_Advstart 				( 0x0030 | xclass_Bool )
#define  xtyp_Advstop 				( 0x0040 | xclass_Notification )
#define  xtyp_Execute 				( 0x0050 | xclass_Flags )
#define  xtyp_Connect 				( 0x0060 | xclass_Bool or xtypf_NoBlock )
#define  xtyp_Connect_Confirm ( 0x0070 | xclass_Notification or xtypf_NoBlock )
#define  xtyp_Xact_Complete		( 0x0080 | xclass_Notification )
#define  xtyp_poke 						( 0x0090 | xclass_Flags )
#define  xtyp_Register 				( 0x00A0 | xclass_Notification or xtypf_NoBlock )
#define  xtyp_Request 				( 0x00B0 | xclass_Data )
#define  xtyp_Disconnect 			( 0x00C0 | xclass_Notification or xtypf_NoBlock )
#define  xtyp_Unregister 			( 0x00D0 | xclass_Notification or xtypf_NoBlock )
#define  xtyp_Wildconnect 		( 0x00E0 | xclass_Data or xtypf_NoBlock )

#define  xtyp_Mask 		0x00F0
#define  xtyp_Shift		4  								// shift to turn xtyp_ into an index

// Timeout constants

#define  timeout_Async		-1

// Transaction ID constatnts
#define  qid_Sync 				-1

// public strings used in DDE

#define  szddesys_Topic 				'System'
#define  szddesys_Item_Topics 	'Topics'
#define  szddesys_Item_SysItems	'SysItems'
#define  szddesys_Item_RtnMsg 	'ReturnMessage'
#define  szddesys_Item_Status 	'Status'
#define  szddesys_Item_Formats 	'Formats'
#define  szddesys_Item_Help 		'Help'
#define  szdde_Item_Itemlist 		'TopicItemList'

//*****************************************************************************
//  The following constants and functions would never be used in our context.
//*****************************************************************************
// API entry points
/*
  TFNCallback = function (CallType, Fmt: UINT; Conv: HConv; hsz1, hsz2: HSZ;
    Data: HDDEData; Data1, Data2: DWORD): HDDEData stdcall;

#define  cbr_Block 		0xFFFFFFFF

// DLL registration functions

import int	DdeInitialize(
		*DWord	Inst,
		Pointer	Callback,
		int			Cmd,
		int			Res
		) user32 'DdeInitializeA';

// Callback filter flags for use with standard apps.

#define  CBF_FAIL_SELFCONNECTIONS		0x00001000
#define  CBF_FAIL_CONNECTIONS 			0x00002000
#define  CBF_FAIL_ADVISES 					0x00004000
#define  CBF_FAIL_EXECUTES 					0x00008000
#define  CBF_FAIL_POKES 						0x00010000
#define  CBF_FAIL_REQUESTS 					0x00020000
#define  CBF_FAIL_ALLSVRXACTIONS 		0x0003f000

#define  CBF_SKIP_CONNECT_CONFIRMS	0x00040000
#define  CBF_SKIP_REGISTRATIONS 		0x00080000
#define  CBF_SKIP_UNREGISTRATIONS 	0x00100000
#define  CBF_SKIP_DISCONNECTS 			0x00200000
#define  CBF_SKIP_ALLNOTIFICATIONS 	0x003c0000

// Application command flags

#define  APPCMD_CLIENTONLY 		0x00000010
#define  APPCMD_FILTERINITS 	0x00000020
#define  APPCMD_MASK 					0x00000FF0

// Application classification flags

#define  APPCLASS_STANDARD 		0x00000000
#define  APPCLASS_MASK 				0x0000000F

import Bool	DdeUninitialize( DWord Inst )
		user32 'DdeUninitialize';
*/

// conversation enumeration functions

import HConvList DdeConnectList(
		DWord			Inst,
		HSz				Service,
		HSz				Topic,
  	HConvList	ConvList,
		Pointer		CC
		)	user32 'DdeConnectList';

import HConv	DdeQueryNextServer(
		HConvList	ConvList,
		HConv			ConvPrev
		)	user32 'DdeQueryNextServer';

import Bool	DdeDisconnectList( HConvList ConvList )
		user32 'DdeDisconnectList';

// conversation control functions

import HConv	DdeConnect(
		DWord		Inst,
		HSz			Service,
		HSz			Topic,
		Pointer	CC
		) user32 'DdeConnect';

import Bool	DdeDisconnect( HConv Conv )
		user32 'DdeDisconnect';

import HConv	DdeReconnect( HConv Conv )
		user32 'DdeReconnect';

import int	DdeQueryConvInfo(
		HConv		HConv,
		DWord		Transaction,
		Pointer	ConvInfo
		) user32 'DdeQueryConvInfo';

import Bool	DdeSetUserHandle(
		HConv	HConv,
		DWord Id,
		Dword User
		) user32 'DdeSetUserHandle';

import Bool	DdeAbandonTransaction(
		DWord	Inst,
		HConv	Conv,
		DWord	Transaction
		) user32 'DdeAbandonTransaction';

// app server interface functions

import Bool	DdePostAdvise(
		DWord	Inst,
		HSz		Topic,
		HSz		Item
		) user32 'DdePostAdvise';

import Bool	DdeEnableCallback(
		DWord	Inst,
		HConv	Conv,
		int		Cmd
		) user32 'DdeEnableCallback';


#define  ec_EnableAll 		0
#define  ec_Enableone 		st_BlockNext
#define  ec_Disable 			st_Blocked
#define  ec_Querywaiting	2


import HddeData	DdeNameService(
		DWord	Inst,
		HSz		HSz1,
		HSz		HSz2,
		int		Cmd
		) user32 'DdeNameService';

#define  Dns_Register 		0x0001
#define  dns_Unregister		0x0002
#define  dns_FilterOn 		0x0004
#define  dns_FilterOff 		0x0008

// app client interface functions

import HDdeData	DdeClientTransaction(
		Pointer	Data,
		DWord		DataLen,
		HConv		Conv,
		HSz			Item,
		int			Fmt,
		int			DataType,
		DWord		Timeout,
		Pointer	Result
		) user32 'DdeClientTransaction';

// Alias with Data passed as Ascciz intead of Pointer
import HDdeData	DdeClientTransactionZ(
		Asciiz	Data,
		DWord		DataLen,
		HConv		Conv,
		HSz			Item,
		int			Fmt,
		int			DataType,
		DWord		Timeout,
		Pointer	Result
		) user32 'DdeClientTransaction';

// data transfer functions

import HDdeData	DdeCreateDataHandle(
		DWord		Inst,
		Pointer	Src,
  	DWord		cb,
		DWord		Off,
		HSz			Item,
		int			Fmt,
		int			Cmd
		) user32 'DdeCreateDataHandle';

import HDdeData	DdeCreateDataHandleZ(
		DWord		Inst,
		*Asciiz	Src,
  	DWord		cb,
		DWord		Off,
		HSz			Item,
		int			Fmt,
		int			Cmd
		) user32 'DdeCreateDataHandle';

import HDdeData	DdeAddData(
		HDdeData	Data,
		Pointer		Src,
  	DWord			cb,
		DWord			Off
		) user32 'DdeAddData';

import DWord	DdeGetData(
		HDdeData	Data,
		Pointer		Dst,
	  DWord			Max,
		DWord			Off
		) user32 'DdeGetData';

import DWord	DdeGetDataWord(
		HDdeData	Data,
		*Word			Dst,
	  DWord			Max,
		DWord			Off
		) user32 'DdeGetData';

import DWord	DdeGetDataDWord(
		HDdeData	Data,
		*DWord		Dst,
	  DWord			Max,
		DWord			Off
		) user32 'DdeGetData';

import DWord	DdeGetDataZ(
		HDdeData	Data,
		*Asciiz		Dst,
	  DWord			Max,
		DWord			Off
		) user32 'DdeGetData';

import Pointer	DdeAccessData(
		HDdeData	Data,
		*DWord		DataSize
		) user32 'DdeAccessData';

import Bool	DdeUnaccessData( HDdeData Data )
		user32 'DdeUnaccessData';

import Bool	DdeFreeDataHandle( HDdeData Data )
		user32 'DdeFreeDataHandle';

#define  hdata_AppOwned		0x0001

import int	DdeGetLastError( DWord Inst )
		user32 'DdeGetLastError';

// error codes

#define  dmlerr_No_Error 							0  // must be 0

#define  dmlerr_First 								0x4000

#define  dmlerr_AdvAckTimeout 				0x4000
#define  dmlerr_Busy 									0x4001
#define  dmlerr_DataAckTimeout 				0x4002
#define  dmlerr_Dll_Not_Initialized		0x4003
#define  dmlerr_Dll_Usage 						0x4004
#define  dmlerr_ExecAckTimeout 				0x4005
#define  dmlerr_InvalidParameter 			0x4006
#define  dmlerr_Low_Memory 						0x4007
#define  dmlerr_Memory_Error 					0x4008
#define  dmlerr_NotProcessed 					0x4009
#define  dmlerr_No_Conv_Established 	0x400a
#define  dmlerr_PokeAckTimeout 				0x400b
#define  dmlerr_PostMsg_Failed 				0x400c
#define  dmlerr_ReEntrancy 						0x400D
#define  dmlerr_Server_Died 					0x400E
#define  dmlerr_Sys_Error 						0x400F
#define  dmlerr_UnadvAckTimeout 			0x4010
#define  dmlerr_Unfound_Queue_Id 			0x4011

#define  dmlerr_Last 									0x4011

import HSz	DdeCreateStringHandle(
		DWord		Inst,
		Asciiz	psz,
		int			CodePage
		) user32 'DdeCreateStringHandleA';

import DWord	DdeQueryString(
		DWord		Inst,
		HSz			HSz,
		Asciiz	psz,
  	DWord		Max,
		int			CodePage
		) user32 'DdeQueryStringA';

import Bool	DdeFreeStringHandle( DWord Inst, HSz HSz )
		user32 'DdeFreeStringHandle';

import Bool	DdeKeepStringHandle( DWord Inst, HSz HSz )
		user32 'DdeKeepStringHandle';

import int	DdeCmpStringHandles( HSz HSz1, HSz HSz2 )
		user32 'DdeCmpStringHandles';


// Mew32 added functions

import DWord	GetDdeInstance( )
		MewLib32 'GetDdeInstance';
