
#define wm_ChildSize        1324              // Client Size changing to Children
#define wm_ParentSize       1325
#define wm_NewActiveMdi     1330              // New active MDI window
#define wm_StatPref         1331
#define wm_NeedParentSize   1332
#define wm_TabRemoved       1400        // Tab was removed (dialog boxes only)

#define wm_Mew_DlgReturn 		( wm_User + 200 )
#define wm_Mew_DlgSetHelp   ( wm_user + 202 )

#define _fc_Ignore_Case   	0x0001
#define _fc_Ignore_Indent 	0x0002
#define _fc_Ignore_Blank  	0x0004
#define _fc_Ignore_Tabs   	0x0008


#define _MAX_WINDOWS				255

// Structure for parsing WM_COMMAND messages
structure WM_Command_Struct
{
	word NotifyCode;
  word CtrlId;
  int  CtrlHwnd;
}

/*
  Parses the WParam and LParam paramaters into the appropriate parts for a
  wm_Command or wm_SysCommand message.  This handles the difference between
  Win 16 and Win 32.
*/
import void   ParseWmCommand  ( Pointer WCS, DWord WParam, DWord LParam )
		MewLib32 'ParseWmCmd';

import void   CreateWmCommand ( Pointer WCS,*DWord WParam, *DWord LParam )
		MewLib32 'CreateWmCommand';

import Word   Mew_RegisterDll   ( Asciiz Name )
		MewLib32 'Mew_RegisterDll';

import Word   Mew_UnregisterDll ( Asciiz Name )
		MewLib32 'Mew_UnregisterDll';

// Hooks into the common dialogs
import Word   HookFilePromptWithMacro(
		Pointer FileRec,
		Asciiz	Macro_Name
		)  MewLib32 'HookFilePromptWithMacro';

import Word   HookColorPromptWithMacro(
		Pointer	ColorRec,
		Asciiz 	Macro_Name
		)  MewLib32 'HookColorPromptWithMacro';

import Word   HookPrintPromptWithMacro(
		Pointer	PrintRec,
		Asciiz 	PD_Macro_Name,
		Asciiz 	PS_Macro_Name
		)  MewLib32 'HookPrintPromptWithMacro';

import Word   HookFontPromptWithMacro(
		Pointer	FontRec,
		Asciiz 	Macro_Name
		)  MewLib32 'HookFontPromptWithMacro';

// Get/Set a Memory Structure in Windows global memory
import VOID   GetGlobalStructure  (
    DWORD handle,
    POINTER dest,
    DWORD size
    ) MewLib32 'GetGlobalStructure';

import VOID   SetGlobalStructure  (
    DWORD handle,
    POINTER src,
    DWORD size
    ) MewLib32 'SetGlobalStructure';

// Find version of Common Control Library
import int  CommonControl_Version (
    *DWORD major,
    *DWORD minor
    ) MewLib32 'CommonControl_Version';

import void   ZShortenPath(
		*Asciiz FPath,
		Word 		Max,
		int 		DC,
		int 		Font,
		Word 		WPixels
		) MewLib32 'ZShortenPath';

import DWord	GetShiftUpTime( )
		MewLib32 'GetShiftUpTime';

import DWord  GetCtrlUpTime( )
		MewLib32 'GetCtrlUpTime';

import DWord  GetAltUpTime( )
		MewLib32 'GetAltUpTime';


import dword   InqInMouseLoop            () MEWLIB32 'InqInMouseLoop';

import VOID   FreeCurrentUndoBuffer     (DWORD wn) MEWLIB32 'FreeUndoBuffer';
import void		Mew_ScrollUp( int flags,Word Count )
		MewLib32 'ScrollUp';

import void		Mew_ScrollDown( int flags,Word Count )
		MewLib32 'ScrollDown';
import VOID   MEW_Set_C_Row( DWORD wn, dWORD r ) MEWLIB32 'Mew_Set_C_Row';

import void   SetCursorLock( DWord Win, DWord Id )
		MewLib32 'SetCursorLock';

  // Set the global search highlight string
  // NOTE setting it to "" will turn global search highlight off
import void   SetSearchHighlightStr( Asciiz S, DWord Flags )
	  MewLib32 'SetSearchHighlightStr';

  // Store the global search highlight string into str s
import void   GetSearchHighlightStr( *Asciiz S, *DWord Flags )
		MewLib32 'GetSearchHighlightStr';

import Word   GetSecondLanguage( DWord WN, *Asciiz S )
    MewLib32 'MewGetSecondLanguage';

import VOID SyntaxSet(
		Asciiz 	_Name,
		Word 		_Flags,
		Asciiz	_Symbols,
		Asciiz 	_String_Chars,
		Asciiz 	_Lit_Chars,
    Asciiz 	_Eol_Comment,
    Word   	_Eol_Comment_Col,
    Asciiz 	_Eol_Comment2,
    Word   	_Eol_Comment2_Col,
    Asciiz 	_Eol_Comment3,
    Word   	_Eol_Comment3_Col,
    Asciiz 	_Eol_Comment4,
    Word   	_Eol_Comment4_Col,
    Asciiz 	_Op_Comment1,
    Asciiz 	_En_Comment1,
    Asciiz 	_Op_Comment2,
    Asciiz 	_En_Comment2,
		Asciiz 	_Numeric_Chars
 		) MewLib32 'SyntaxSet';

import void SyntaxAddKeywords(
		Asciiz	_Name,
		Asciiz 	_Keywords,
		Word 		Level
		) MewLib32 'SyntaxAddKeywords';

import void  DrawBitmap(
		int xDC,
		int	xBitmap,
		int xStart,
		int yStart,
		int Flags
		) MewLib32 'DrawBitmap';

import void  DrawBitmap256(
		int	xDC,
		int	xBitmap,
		int xStart,
		int yStart,
		int Flags
		) MewLib32 'DrawBitmap256';

import void  DrawBitmap256Ex(
		int xDC,
		int	xBitmap,
		int xStart,
		int yStart,
		int	W,
		int	H,
		int Flags
		) MewLib32 'DrawBitmap256Ex';

import void  DrawBitmapBkColorEx(
		int 		xDC,
		int			xBitmap,
		Pointer TR,
		int 		Flags,
		int 		Idx,
		DWord 	TC
		) MewLib32 'DrawBitmapBkColorEx';

import void  DrawBitmapBkColorRes(
		int 		xDC,
		Asciiz 	P,
		int 		xStart,
		int 		yStart,
		int 		Flags,
		int			Idx,
		DWord 	TC
		) MewLib32 'DrawBitmapBkColorRes';

import Word		Win3_Copy( )
		MewLib32 'Win3_Copy';

import Word   Win3_Paste( )
		MewLib32 'Win3_Paste';

import Word   Win3_Clipboard( )
		MewLib32 'Win3_Clipboard';

import Bool   BufferToText( int VP )
		MewLib32 'BufferToText';

import Word   TextToBuffer(
		*DWord 	VP,
		Word 		S,
		Bool 		Realloc_To_Size
		) MewLib32 'TextToBuffer';
/*
import VOID   BufferEraseNoReset()                                            MEWLIB 210;
*/
import void		BufferLoadFile( Asciiz FN, DWord LineCount, Bool No_Reset )
		MewLib32 'BufferLoadFile';


import BOOL   WcmdIsEnabled   (DWORD window_num, DWORD wid ) Mewlib32 'WcmdIsEnabled';

import DWORD  ProcessDisableString( Asciiz s ) mewlib32 'ProcessDisableString';

import void   SetFileSaveLock( Word LockMode )
		MewLib32 'SetFileSaveLock';

import word   GetFileSaveLock( )
		MewLib32 'GetFileSaveLock';

import void   GetRealFileName( *Asciiz S )
		MewLib32 'GetRealFileName';

import dword  Fcompare  ( dWORD w1, dWORD w2, dWORD tw, *DWORD c1, *DWORD c2,
                          DWORD line_count1, DWORD line_count2,
													dWORD  rcol1, dWORD rcol2,
                          *DWORD twl, DWORD true_eof1, DWORD true_eof2,
                          dWORD flags
                        ) mewlib32 'FCompare';


// Encrypt and Decypher string routines
import void EncryptStr(
		Pointer	S,
		Pointer Key
		)  MewLib32 'EncryptStr';

import void DecypherStr(
		Pointer S,
		Pointer Key
		)  MewLib32 'DecypherStr';

/*
import INT    ActivateAppMenu ( Asciiz app, Asciiz windowclass, Asciiz menustr, Word Active ) MEWLIB 70;
import WORD   FindTask        ( Asciiz app )                      MEWLIB 71;
import WORD   FindTaskWindow  ( WORD task, Asciiz windowclass )   MEWLIB 72;
import WORD   FindChildWindow ( WORD parent, Asciiz windowclass ) MEWLIB 73;
import INT    ActivateWinMenu ( WORD wnd, Asciiz menustr, Word Active ) MEWLIB 74;

import DWORD  GetStartupMem   () MEWLIB 90;
import DWORD  GetMemAvail     () MEWLIB 91;
import DWORD  GetTotalVMBlocks() MEWLIB 92;
import DWORD  GetFileVMBlocks () MEWLIB 93;
*/

import VOID   MEWCloseInternalBuffers() mewlib32 "MEWCloseInternalBuffers";


import VOID  SetToolbarUpdate  (
    BOOL b
    ) mewlib32 'SetToolbarUpdate';
import BOOL  GetToolbarUpdate  (
    ) mewlib32 'GetToolbarUpdate';

import Word   Get_Window_Font (
		Word 		WN,
		*Asciiz	Font_Name,
		*int 		font_size,
    *Word 	Oem_Ansi
		) MewLib32 'Get_Window_Font';

import Word   Get_Window_Font_Handle (
		Word	WN,
		*Word NHandle,
		*Word BHandle,
    *Word IHandle,
		*Word IBhandle
		) MewLib32 'Get_Window_Font_Handle';

import Word   Set_Window_Font (
		Word 		WN,
		Asciiz	Font_Name,
		int 		Font_Size,
    Word 		Oem_Ansi
		) MewLib32 'Set_Window_Font';


import Word   Get_OEM_ANSI (
    Word WN
    ) MewLib32 'Get_OEM_ANSI';

import void   Set_OEM_ANSI (
    Word WN,
    Word Oem_Ansi
    ) MewLib32 'Set_OEM_ANSI';


// Ruler functions
import Word   RulerOn(
    Word WN
    ) MewLib32 'RulerOn';

import Word   RulerOff(
    Word WN
    ) MewLib32 'RulerOff';

import Word   RulerStatus(
    Word WN
    ) MewLib32 'RulerStatus';

import Word   RulerZero(
    Word WN,
    Word Pos
    ) MewLib32 'RulerZero';

// Print Functions
import WORD   PrintFromWindow   (
    DWORD parent,
    DWORD win,
    POINTER pds,
    POINTER pPrnOpt
    ) Mewlib32 'PrintFromWindow';

import WORD   GetDevNamesHandle ()                      mewlib32 'GetDevNamesHandle';
import WORD   SetDevNamesHandle ( Int handle)           mewlib32 'SetDevNamesHandle';
import WORD   GetDevModeHandle  ()                      mewlib32 'GetDevModeHandle';
import WORD   SetDevModeHandle  ( Int handle)           mewlib32 'SetDevModeHandle';

import Word SetRepeat( Word Count, Word Key, Word Refresh ) MewLib32 'SetRepeat';

import Word GetRecord( ) MewLib32 'GetRecord';

import int	GetTextExtent(
		int			dc,
		Asciiz 	String,
		Word		cbString
		) MewLib32 'GetTextExtent';

IMPORT BOOL RegisterMEWResource(DWORD hInstanceOfResourceFile) MewLib32 'RegisterMEWResource';

IMPORT HBITMAP FetchBitmap(
		DWORD    iRefType,             // type of reference to button
		ASCIIZ  lpszNewButtonRef    // new name of bitmap to display
) MewLib32 'FetchBitmap';

IMPORT DWORD FetchResource(
							POINTER hInstance,
							DWORD iRefType,
							ASCIIZ lpszResourceRef,
							DWORD type) MewLib32 'FetchResource';

IMPORT void DrawMEWButton( DWORD lparam, DWORD extrahandle, DWORD bw, DWORD bh, ASCIIZ p, DWORD flags ) MewLib32 'DrawMEWButton';

IMPORT DWORD GetBitmapBkColor( ASCIIZ lpszRef, INT iref ) mewlib32 "GetBitmapBkColor";


import DWORD LocateThreadWindow32 ( DWORD thread, ASCIIZ classname  )
  mewlib32 "LocateThreadWindow32";
import DWORD LocateChildWindow32  ( DWORD parent, ASCIIZ classname )
  mewlib32 "LocateChildWindow32";
import DWORD LocateTopWindow32    ( ASCIIZ classname )
  mewlib32 "LocateTopWindow32";
import DWORD LocateTopWindowTitle32    ( ASCIIZ classname, ASCIIZ title )
  mewlib32 "LocateTopWindowTitle32";
import DWORD GetWinMenu32         ( DWORD window, ASCIIZ menustr, *DWORD menuhandle )
  mewlib32 "GetWinMenu32";
import DWORD ActivateWinMenu32    ( DWORD window, ASCIIZ menustr, DWORD Activate )
  mewlib32 "ActivateWinMenu32";
import DWORD ActivateMenu32       ( ASCIIZ windowclass, ASCIIZ menustr, DWORD Activate )
  mewlib32 "ActivateMenu32";

import DWORD GetWindowText32      ( DWORD  hWnd, POINTER lpString, DWORD nMaxCount )
  USER32 "GetWindowTextA";
import DWORD GetWindowThread32    ( DWORD  hWnd, POINTER p )
  USER32 "GetWindowThreadProcessId";
import DWORD SetForegroundWindow32( DWORD hwnd )
  USER32 "SetForegroundWindow";
import DWORD FindWindow32         ( ASCIIZ Classname, ASCIIZ WindowName)
  USER32 "FindWindowA";
import DWORD FindWindowN32        ( ASCIIZ Classname, DWORD WindowName)
  USER32 "FindWindowA";
import DWORD FindWindowC32        ( DWORD Classname, ASCIIZ WindowName)
  USER32 "FindWindowA";
import DWORD ShowWindow32         ( DWORD hWnd, DWORD nCmdShow)
  USER32 "ShowWindow";
import DWORD IsIconic32           ( DWORD hWnd)
  USER32 "IsIconic";
import DWORD BringWindowToTop32   ( DWORD hWnd)
  USER32 "BringWindowToTop";

// Windows Functions
import void ReorderWindows(
    int Win,
    int AfterWin
    )   MewLib32 "ReorderWindows";

// Editing functions
import void   SetCursorRestrict  (
    DWORD r
    ) MewLib32 "SetCursorRestrict";
import dword  GetCursorRestrict  (
    ) MewLib32 "GetCursorRestrict";

import void   SetWTabMode  (
    DWORD r
    ) MewLib32 "SetWTabMode";

import dword  GetWTabMode  (
    ) MewLib32 "GetWTabMode";


// Tab Control

#define  METW_OFF         1
#define  METW_TOP         2
#define  METW_BOTTOM      3
#define  METW_LEFT        4
#define  METW_RIGHT       5


#define  METWX_PROPER      0x0001
#define  METWX_SHOWHIDDEN  0x0002
#define  METWX_SHOWICONIC  0x0008
#define  METWX_MULTILINE   0x0010
#define  METWX_BUTTONS     0x0020
#define  METWX_NOBITMAPS     0x0040

import void TabWindow_Set     (
    DWORD enable,                       // Use METW flags
    DWORD ex_style,                     // Use METWX Flags
    ) mewlib32 "TabWindow_Set";

//import void TabWindow_SetFont (
//    ASCIIZ name,
//    INT charsize,
//    INT charweight
//    ) mewlib32 "TabWindow_SetFont";

//import void TabWindow_SetColor (
//    DWORD bg
//    ) MewLib32 "TabWindow_SetColor";

import void TabWindow_Redraw (
    ) mewlib32 "TabWindow_Redraw";

import void TabWindow_TabDraw ( pointer p, int bcolor
    ) mewlib32 "TabWindow_TabDraw";


import void SetTabDrawStruct( pointer ts ) mewlib32 "SetTabDrawStruct";
import void GetTabDrawStruct( pointer ts ) mewlib32 "GetTabDrawStruct";

import int GetSysCmdWid() mewlib32 "GetSysCmdWid";

import void SetStatWinRW( int i ) mewlib32 "SetStatWinRW";

import int GetResHWnd( ) mewlib32 "GetResHWnd";

import void SetResHWnd( int i ) mewlib32 "SetResHWnd";

import int GetMDIEdit( int w ) mewlib32 "GetMDIEdit";
import int GetMDIWindowNum ( int wnd ) mewlib32 "GetMDIWindowNum";

IMPORT dword LoadBitmapFile(asciiz FileName,hWnd HWindow,
                    pointer Width, pointer Height, pointer hCP, pointer r) mewlib32 'LoadBitmapFile';

import void ResetLastCursorPos( int wn ) mewlib32 "ResetLastCursorPos";


import void SetMDIResizeMessages( BOOL m ) mewlib32 "SetMDIResizeMessages";
import BOOL GetMDIResizeMessages(  ) mewlib32 "GetMDIResizeMessages";

import int GetMatchGroupCount( )
    MewLib32 'GetMatchGroupCount';

import void GetMatchGroup( Pointer GroupStr, int Group )
    MewLib32 'GetMatchGroup';

import void Get_Highlight(
    *DWord StartLine,
    *int StartCol,
    *DWord EndLine,
    *int EndCol
    ) MewLib32 'Get_Highlight';

// DO WE NEED THESE   JKP
import Byte		UseLongNames( )
		MewLib32 'UseLongNames';
