/******************************************************************************
														 Multi-Edit Macro File
															 18-Sep-97  17:12

	Function: Update and add-on package install/manage macro constants.

	Author  : Dan Hughes

	$Header: /MeWin32/SH/UPDATE.SH 2     9/20/97 2:08a Dan $

							 Copyright (C) 1997 by American Cybernectics, Inc.
 *******************************************************************( ldh )***/
// Func constants
#define _dbu_func_Add     0
#define _dbu_func_Delete  1

#define _baseErr_DbTools  0
#define _baseErr_File     3000

#define _max_WCmds        1000
#define _max_IfRc         16

// Install dialog control ids
#define id_ins_SrcDir			1000
#define id_ins_InsDir			1001
#define id_ins_PkgLst			1002
#define id_ins_LogChk			1003

#define id_ins_MsgLine		1100
#define id_ins_HlpLine		1101

#define id_ins_BrowseBtn	2010
#define id_ins_RescanBtn	2011
#define id_ins_InstallBtn	2012
#define id_ins_ViewDocBtn	2013
#define id_ins_ViewLogBtn	2014
#define id_ins_DelLogBtn	2015
#define id_ins_EnableBtn	2016
#define id_ins_RmCmdsBtn	2017

#define _ins_BtnWidth			12

// Config file version constants
#define _db_cfv_Page			"CFGFILE.VER"

// Config file version field names
#define _db_cfv_Cur				"CUR"
#define _db_cfv_Ver				"VER"


global {
	int g_InsLogOn			"@InsLogOn";
	int g_InsVerifyOn		"@InsVerifyOn";
	int g_InsNoMsgBox		"@InsNoMsgBox";
	int g_InsLstWin			"!InsLstWin";
	int g_SrcDirChanged	"!SrcDirChanged";
	int g_InsMEWRestart	"!InsMEWRestart";
	int g_AutoStart			"!InsAutoStart";
	int g_CfgFileVer		"!CfgFileVer";

	str g_InsLstFile		"!InsLstFile";
	str g_SrcDir				"@SrcDir";
	str g_InstallDir		"@InstallDir";
	str g_InsEndMac			"@InsEndMac";
	str g_InsLogFile		"@InsLogFile";
}

struct TWCmds {
	int Entries;
	int Old[ _max_WCmds ];
	int New[ _max_WCmds ];
}

struct IfArray {
	int Active[ _max_IfRc ];
}

prototype Update {

	int EnablePackage( str PackageName, int Enable );
/******************************************************************************
	Function: Enable/disable a registered add-on package

	Entry   : str PackageName	- The registered addon package name						 (/P=)
						int Enable			- True to enable, False to disable the package (/E=)

	Exit    : int
							_NoError					- Success, PackageName was updated
							_ErrorNoFile      - Failure, "MECONFIG.DB" not found
							_ErrorNoDbPage    - Failure, "PACKAGES" not found in "MECONFIG.DB"
							_ErrorNoDbRecord  - Failure, no record matching PackageName found
********************************************************************( ldh )***/

	void Update( str FName );
	void Install( str FName, int AutoStart );
/******************************************************************************
  Function: Install addon packages.

  Entry   : str FName       - Name of install file, 										(/F=)
 																"" defaults to INSTALL.LST
						int AutoStart		- Auto start install flag                   (/A=)
																0 - Show dialog
																1 - Auto install
																2 - Auto install, forced full install
********************************************************************( ldh )***/

	void Uninstall( );
/******************************************************************************
  Function: Uninstall addon package
********************************************************************( ldh )***/
}
