// $Header: /MeWin32/SH/meutil.sh 4     10/31/97 1:45p Dan $

// ValidatePath flag constants
#define _vp_Create			0x0001
#define _vp_NoPrompt		0x0002

prototype Meutil {
  int CheckPersistent   ( );
  int CheckBlock        ( );
  int CheckBuffer       ( );
  int CheckMarking      ( );
  int CheckNoMarking    ( );
  int CheckLineMarking  ( );
  int CheckColMarking   ( );
  int CheckStrMarking   ( );
  int CheckNIStrMarking ( );

	int UndBlk( int InBlk, int Message, str Misc );
/******************************************************************************
  Function: Undents a marked block of text one tab stop.
  Entry   : int InBlk		 Will only undent when cursor is in block ( /I=1 )
 						int Message	 Show message ( /NM=1 no message )
						str Misc		 Not used use "" ( for future expansion )

  Exit    :	int
 							True 	= Block undented
							False	=	Block not undented
********************************************************************( ldh )***/

	int IndBlk( int InBlk, int Message, str Misc );
/******************************************************************************
  Function: Indents a marked block of text one tab stop.
  Entry   : int InBlk		 Will only indent when cursor is in block ( /I=1 )
 						int Message	 Show message ( /NM=1 no message )
						str Misc		 Not used use "" ( for future expansion )

  Exit    :	int
 							True 	= Block indented
							False	=	Block not indented
**********************************************************************(ldh)***/

	void SwitchToBuffer( int Buf_Num );
	void ShowClipboard( int Buf_Num );

	void Cut( int Buf_Num, str Flags );
/******************************************************************************
  Function: Copies, Moves and/or Appends text to a hidden buffer.
  Entry   : int Buf_Num		The buffer # (0 is the default) ( /B=# )
						str Flags			The operation flags
							/M    			- Move text (else copy text).
							/A    			-	Append text (else erase old buffer).
							/E    			- Erase buffer, perform no move or copy.
							/O=1 	 			- The marked block will be turned turned off after the
													  operation.
   						/I=1	 			- Cut block only if cursor in block (else cut line).
							/NM=1				- Show no messages
							/NEM=1		  - Will not end block marking
            	/NW=1   		- Windows version only.  Do NOT copy block of text
                    			  to Windows clipboard.
	Exit    : None.
********************************************************************( ldh )***/

  int  Launch_HelperApp  ( str fn, int xlate, int notify );
/******************************************************************************
  Function: Launches a external app based on filename extension.

********************************************************************( jkp )***/

	int CreatePath( str Path );
/******************************************************************************
	Function: Creates a directory tree if it does not exist.
	Entry   : str Path		- The directory to create.										( /P= )
	Exit    : int					- True if directory existed or was created otherwise
 													false.
 *******************************************************************( ldh )***/

	int ValidatePath( str Path, str PathName, int Flags );
/******************************************************************************
	Function: Check if a directory exists and optionally prompt and create the
						directory tree if needed.

	Entry   : str Path      - The directory name												( /P= )
						str PathName	- The name of the directory									( /PN= )
						int Flags			- Directory creation flags.									( /F= )
							_vp_Create    - Create the directory if it does not exist
							_vp_Prompt		- Prompt before creating the directory

	Exit    : int						- true if directory exists or was created else false.
 *******************************************************************( ldh )***/
}
