//******************************************************************************
//
//  $Header: /MeWin32/SH/mewtree.sh 26    12/09/97 11:20a Johnp $
//
//               Copyright (C) 1997 by American Cybernectics, Inc.
//******************************************************************************

#Define Wm_Tree_Getwin         (Wm_User + 101)
#Define Wm_Tree_Setdimensions  (Wm_User + 102)
#Define Wm_Tree_Getstartrec    (Wm_User + 103)
#Define Wm_Tree_Getline        (Wm_User + 104)
#Define Wm_Tree_Setbuf         (Wm_User + 105)
#Define Wm_Tree_Setflags       (Wm_User + 106)
#Define Wm_Tree_Redraw         (Wm_User + 107)
#Define Wm_Tree_Getbuf         (Wm_User + 108)
#Define Wm_Tree_Setmacroproc   (Wm_User + 109)
#Define Wm_Tree_Setkeywcmd     (Wm_User + 110)
#Define Wm_Tree_SetEdit        (Wm_User + 112)


#Define _tree_Flag_Incsearch        0x0001
#Define _tree_Flag_Calccount        0x0002
#Define _tree_Flag_Autowidth        0x0000
#Define _tree_Flag_Ptr              0x0008
#Define _tree_Flag_Scrollbar        0x0010
#Define _tree_Flag_Extendedsel      0x0020
#Define _tree_Flag_Hscroll          0x0040
#Define _tree_Flag_Nodblclick       0x0080


prototype MewTree
{
  int Tree_Create(   int mwin,              // The edit buffer/window number
										 int startline,         // The starting line in the buffer
										 int count,             // The number of lines
										 int x, y, w, h,        // Position and size in pixels
										 int id,                // Ctrl id
                     int flags,             // Flag bits. See _TREE_FLAG_xxxx
										 int parent,            // Parent window
										 str disp_str           // display string
										 );

  void Tree_SetKeys         ( int tree_handle, int inscmd, int delcmd, int retcmd );
  void Tree_SetItemLabel    ( int tree_handle, int item_handle, str item_string );
  void Tree_EditItem        ( int tree_handle, int item_handle);

  void Tree_SetEdit         ( int tree_handle, int editcmd );
  void Tree_SetMacroProc    ( int tree_handle, str MacroStr );
  void Tree_SelectItem      ( int tree_handle, int item);
  int  Tree_SetBuf          ( int tree_handle, int window, int start_line);
  void Tree_SetIndent       ( int tree_handle, int width) ;
  int  Tree_GetIndent       ( int tree_handle);
  void Tree_SetFlags        ( int tree_handle, int flags);
  void Tree_GetStartCount   ( int tree_handle, int &start_line, int &count );
  int  Tree_GetItemLine     ( int tree_handle, int item_handle );
  int  Tree_GetItemSelected ( int tree_handle );
  int  Tree_GetItemRect     ( int tree_handle, int item_handle, struct TRect item_rect );
  int  Tree_IsItemSelected  ( int tree_handle, int item_handle );
  void Tree_Traverse        ( int tree_handle, int item_handle, str op_macro );
  int  Tree_GetRoot         ( int tree_handle);
  int  Tree_GetNextSibling  ( int tree_handle, int item_handle );
  int  Tree_GetChild        ( int tree_handle, int item_handle );
  int  Tree_ItemHasChildren ( int tree_handle, int item_handle );
  int  Tree_NumItemsSelected( int tree_handle );

}

Import Int TreeList_Create (
  ASCIIZ title,
  int window,
  int style,
  word x, word y, word w, word h,
  int parent,
  word id
  ) Mewlib32 "TreeList_Create";

Import Int Tree_Initialize (
  int tree_handle,
  int count
  ) MewLib32 "TreeList_Initialize";

Import Int Tree_Images (
  int tree_handle,
  ASCIIZ normal_bmp,
  ASCIIZ select_bmp,
  ASCIIZ states_bmps
  ) MewLib32 "TreeList_Images";

Import int Tree_GetItemHandle (
  int tree_handle,
  int line_num
  ) MewLib32 "TreeList_GetItemHandle";

Import int Tree_DeleteItem (
  int tree_handle,
  int item_handle
  ) MewLib32 "TreeList_DeleteItem";
