//                             Project Manager
#define _PRJ_ASSOCIATEPAGE  "ASSOCIATE.DB"
#define _PRJ_FILESPAGE      "FILES.DB"

// Global Messages
#define WM_NEWPROJECT  0x800         // This message is broadcast to open dlgs when
                                     // when a project change occurs.
global
{
  int g_ProjectDlg        '~PrjMgr_Handle';
  int g_RWProjectTab      '~PrjMgr_Tab';

  str g_CurPrj            'PrjCur';             // Current project
  str g_CurPrjName        '!PrjCurName';        // Current project file name
  str g_RootPath          '!PrjRootPath';       // Root path for current project
  str g_FTPHost           '!PrjFtpHost';
  str g_FTPUser           '!PrjFtpUser';
  str g_FTPPass           '!PrjFtpPass';
  str g_FTPRoot           '!PrjFtpRoot';
  int g_FtpTransferMode   '!PrjFtpMode';
  str g_SearchPath        '!PrjSearchPath';  // Search path for opening files

  int g_ProjectSynch      '#g_PrjSynch';
  int g_ProjectHistoryAdd '#g_PrjHistAdd';
}



prototype Project
{
  void  Project_Manager        ( );
  void  SetProject             ( str prjname);
  void  ExpandProjectFileName  ( str &filename);
  int   FirstProjectFile       ( int &PrjFileIndex, str &filename, int flag);
  int   NextProjectFile        ( int &PrjFileIndex, str &filename, int flag);
	int 	ProjectInUse					 ( );

  void  FixProject  (   );

  int   IsProjectFile( str fn);
  /********************************************************************
                                Multi-Edit Macro
                                  1/2/97 1:31PM

    Function: Check if file is in Project list
    Entry   : str fn = Project file name to check  (/FN=)
    Exit    : int     = True if found in list

                  Copyright 1997 by American Cybernetics, Inc.
  ************************************************************( jkp)***/

  int   AddProjectFile            ( str fn, int line);
  /********************************************************************
                                Multi-Edit Macro
                                1/2/96 2:12PM

    Function: Add File to current project
    Entry   : str fn = Name of file to add to project
              int line = line number to add after or 0 to add to end

    Exit    : int non-zero if error

                  Copyright 1997 by American Cybernetics, Inc.
  ************************************************************( jkp)***/

  int   GetProjectListFile        ( int all);
  /********************************************************************
                                Multi-Edit Macro
                                12/5/96 2:12PM

    Function: Gets a list of all files in a project
    Entry   : int all = get all files including non editable.  This is defined by
                Filename extensions.

    Exit    : window_id of list.  It is calling programs responsibility to delete the
                window.  Will be 0 if error.

                  Copyright 1996 by American Cybernetics, Inc.
  ************************************************************( jkp)***/
}