/******************************************************************************
														 Multi-Edit Macro File
															 17-Sep-97  15:18

	Function: Search related macro headers.
	Author  : Dan Hughes

 	$Header: /Me8/SH/search.sh 19    1/19/99 3:04p Dan $

							 Copyright (C) 1997 by American Cybernectics, Inc.
 *******************************************************************( ldh )***/
// Search setup dialog tab sizes
#define _stab_Height					14
#define _stab_Width 					79

// Search tabbed dialog tab constants
#define _tab_sr_Search					1
#define _tab_sr_Replace					2
#define _tab_sr_SearchFiles			3
#define _tab_sr_ReplaceFiles		4
#define _tab_sr_Highlight				5
#define _tab_sr_SearchOptions		6

// ExportList option constants
#define _xo_FSearch		0x0000            // Export multi-file search list
#define _xo_Search		0x0001            // Export search list
#define _xo_FileOnly  0x0004            // Show no export options
#define _xo_Prompt		0x0008            // Show export option dialog
#define _xo_XLine			0x0010	          // Export line number
#define _xo_XData			0x0020            // Export line data
#define _xo_XCount		0x0040            // Export found count

// ExportList position constants
#define _xl_LCol		2                   // Export list line start column
#define _xl_LWidth	8                   // Export list line width

// Search options constants
#define _so_GlobalAllBtn		0x00000001
#define _so_FsLstHide				0x00000002
#define _so_SearchLstHide		0x00000004
#define _so_UseSrDef        0x00000008
#define _so_UseFsDef        0x00000010
#define _so_ShowHis0        0x00000020
#define _so_NoBlkChk        0x00000040

// Global variable name constants
//#define _g_SearchOpts       "SearchOpts"
#define _g_DefSearchOpts   	"#DefSearchOpts"

#define _g_SearchStr				"Search_Str"
#define _g_Switches     		"Switches"
#define _g_DefSwitches			"Def_Switches"

#define _g_ReplaceStr				"Replace_Str"
#define _g_ReplSwitches			"Repl_Switches"
#define _g_DefReplSwitches	"Def_Repl_Switches"

#define _g_FSearchStr				"FSearch_Str"
#define _g_FSwitches				"FSwitches"
#define _g_FFileSpec				"FFileSpec"
#define _g_FSearchPath			"FSearch_Path"
#define _g_DefFSSwitches		"Def_FS_Switches"
#define _g_DefFSearchPath		"Def_FS_Path"

#define _g_FRSwitches				"FRSwitches"
#define _g_FRFileSpec				"FRFileSpec"
#define _g_FRSearchPath			"FRSearch_Repl_Path"
#define _g_DefFRSwitches		"Def_FSR_Switches"
#define _g_DefFRSearchPath	"Def_FSR_Path"

#define _g_SearchColBeg			"SearchColBeg"
#define _g_SearchColEnd			"SearchColEnd"
#define _g_DefSearchColBeg	"#DefSearchColBeg"
#define _g_DefSearchColEnd	"#DefSearchColEnd"

#define _g_HighlightFlags		"GlobalHiliteFlags"
#define _g_DefHiliteFlags		"#DefGlobalHiliteFlags"

global {
	int Reg_Exp_Style;  	// TRUE = Unix style expressions
  int g_FType       		"FsFType";
  int SReturn_Int;   		// Added for Modeless Purposes
	int g_SrCollapsed			"!SRCollapsed";
  int SCaretPos;

	int g_FsMsgDlg				"!FsMsgDlg";

	int g_SRModalDlg			"~SR_Modal";
	int g_hSRDialog				"!hSRDialog";
	int g_SearchTabDlg		"!SearchTabDlg";
	int g_RepSearch				"RepSearch";
	int g_FoundCount			"Found_Count";
	int g_ReplaceCount		"Replace_Count";
	int g_SearchMode			"Search_Mode";
	int g_SearchWin				"!FSearchWin";
  int g_FoundWin        "!FFoundWin";
  int g_TotalFiles      "!FTotalFiles";
	int g_TotalFnd				"!FTotalFnd";
	int g_ExportOpts			"FSExportOpts";

	int	g_SearchColBeg		_g_SearchColBeg;
	int g_SearchColEnd		_g_SearchColEnd;
	int g_DefSearchColBeg	_g_DefSearchColBeg;
	int g_DefSearchColEnd	_g_DefSearchColEnd;

	int	g_SearchTabNo			"#Search_TabNo";
	int g_HighlightFlags 	_g_HighlightFlags;
	int g_DefHiliteFlags	_g_DefHiliteFlags;
//  int g_SearchOpts      _g_SearchOpts;
	int g_DefSearchOpts   _g_DefSearchOpts;

	// Results Window Search list globals
	int g_SearchLstWin		"~SearchLstWin";
	int g_SearchLstTab		"~SearchLstTab";
	int g_SearchLstDlg		"~SearchLstDlg";
	int g_SearchLstCur		"~SearchLstCur";

	// Results Window File Search list globals
	int g_FsLstWin				"~FsLstWin";
	int g_FsLstTab				"~FsLstTab";
	int g_FsLstDlg				"~FsLstDlg";
	int g_FsLstCur				"~FsLstCur";

	str g_SearchStr				_g_SearchStr;
	str g_Switches				_g_Switches;
	str g_DefSwitches			_g_DefSwitches;

	str g_ReplaceStr			_g_ReplaceStr;
	str g_ReplSwitches		_g_ReplSwitches;
	str g_DefReplSwitches	_g_DefReplSwitches;

	str g_FSearchStr			_g_FSearchStr;

	str g_FSwitches				_g_FSwitches;
	str g_FFileSpec				_g_FFileSpec;
	str g_FSearchPath			_g_FSearchPath;
	str g_DefFSSwitches		_g_DefFSSwitches;
	str g_DefFSearchPath	_g_DefFSearchPath;

	str g_FRSwitches			_g_FRSwitches;
	str g_FRFileSpec			_g_FRFileSpec;
	str g_FRSearchPath		_g_FRSearchPath;
	str g_DefFRSwitches		_g_DefFRSwitches;
	str g_DefFRSearchPath _g_DefFRSearchPath;

	str g_FSInfo					"!FSInfo";
}

prototype Search {
	int  ListAllAvailable( );

	str SetSearchHistory( str SearchStr, int SetGlobals, int Window, int CtrlId );

	void SearchGetAlias( int Dlg, int Id, int Flags );
/******************************************************************************
	Function: Called by search dialogs to get aliases
	Entry   : int Dlg   - The window handle of the dialog box 		( /DLGHANDLE= )
      			int Id    - The control id of the text control      ( /ID= )
      			int Flags	- Flags					 						 							( /FLAGS= )

 							0x01  			If set, then set the search type radio buttons.
							 						Only used by the normal search dialog.

             	0x02  			If set, calculate the caret position otherwise, get
													the position from SCaretPos.
********************************************************************( ldh )***/

	void GlobalExpHighlight( str SearchStr, int ExpOn, int CaseSen, int Reset );
/******************************************************************************
  Function: This macro creates processes the Global Expression Highlight
						feature.

  Entry   : str SearchStr		- The search string												( /S= )
      			int ExpOn     	- 																				( /E= )
      			int CaseSen   	-           															( /C= )
      			int Reset     	-             														( /R= )

 						If no search string is passed on the commandline, and /R=1 is not
            passed, then a dialog is brought up.  If a search string is
            passed, then ExpOn=1 turns on Unix expressions, ExpOn=2 turns on
            Classic expressions, CaseSen=1 turns on Case Sensitivity and
            Reset=1 causes the reset of the commandline to be ignored and the
            highlighting to be turned off.
********************************************************************( tmj )***/

	int Create_SR_Dialog( int Search_Mode, int MultiFile, int Prompted,
			int Search_All_Windows );

	void SearchWord( int Direction );
/******************************************************************************
	Function: Search for the currently marked word.
	Entry   : int Direction		- 0 Search forward, 1 - Search backward  	( /D= )
 *******************************************************************( ldh )***/

  str Convsl( str Cs );

	int ExportList( str fname, int options );
/******************************************************************************
	Function: Export the data from the search or multi-file search list.

	Entry   : str fname 		- The filename to write the exported data to.
														Defaults to XLIST.TMP in the temp directory.

						int options 	- Options specifying what data to export

							_xo_FSearch		- Set to export multi-file search list
							_xo_Search		- Set to export search list all occurrences
							_xo_XLine			- Set to export line number
							_xo_XData			- Set to export line data
							_xo_Prompt		- Set to show the export option dialog

 	Exit 		: int						- true if export done, otherwise false
 *******************************************************************( ldh )***/

	int SearchLstGetWin( int SwitchWin, int Action );
/******************************************************************************
	Function: Create and return the window number of the search list results
						window.  If an Action is set then also create or delete the results
						window dialog.

	Entry   : int SwitchWin		- true to return with fs list window current
						int	Action			- Results window action
							_rwa_None				- No action
							_rwa_AddTab		 	- Add tab to results window if not already there
							_rwa_DelTab			- Delete tab from results window if there

	Exit    : int							- The window number of the Fs List window
 *******************************************************************( ldh )***/

	void SearchLstUpdate( );
	void SearchLstUpdateMsg( str Msg );
	void SearchLstUpdateList( int LineCnt, int TotalLines );

	int FsLstGetWin( int SwitchWin, int Action );
/******************************************************************************
	Function: Create and return the window number of the file search list results
						window.  If an Action is set then also create or delete the results
						window dialog.

	Entry   : int SwitchWin		- true to return with fs list window current
						int	Action			- Results window action
							_rwa_None				- No action
							_rwa_AddTab		 	- Add tab to results window if not already there
							_rwa_DelTab			- Delete tab from results window if there

	Exit    : int							- The window number of the Fs List window
 *******************************************************************( ldh )***/

	void FsLstUpdate( int Line );
	void FsLstUpdateMsg( str Msg );
	void FsLstUpdateList( int LineCnt, int TotalLines );
  int SwitchBestFile( int ActiveWinId, str FileName );
}
