// TBWIN.SH :: access to toolbox routines in MEWTLS32.DLL

// Toolbox styles
#define   TBS_NOCAPTION       0x0001      // No caption on toolbox
#define   TBS_FLOATING        0x0002      // Popup toolbox restricted to appwin
#define   TBS_NORESIZE        0x0004      // Toolbox that can not be resized
#define   TBS_KEEPPARENTWIDTH 0x0008      // Keeps parent width
#define   TBS_NOBORDER        0x1000      // is there a border?
#define   TBS_ROVING          0x2000      // popup toolbox that can rove anywhere


#define   TBS_TOPHORIZONTAL     ( TBS_KEEPPARENTWIDTH | TBS_NORESIZE  | TBS_NOCAPTION | 0x0010 )
#define   TBS_BOTTOMHORIZONTAL  ( TBS_KEEPPARENTWIDTH | TBS_NORESIZE  | TBS_NOCAPTION | 0x0020 )
#define   TBS_RIGHTVERTICAL     ( TBS_KEEPPARENTWIDTH | TBS_NORESIZE  | TBS_NOCAPTION | 0x0040 )
#define   TBS_LEFTVERTICAL      ( TBS_KEEPPARENTWIDTH | TBS_NORESIZE  | TBS_NOCAPTION | 0x0080 )


// Tool styles
#define	  TS_TWOSTATE					0x0000			// Two state button
#define		TS_ONESTATE					0x0001			// One state button
#define   TS_DEADSTATE        0x0002      // Dead state button (no msg proc'g)

// Toolbox flags for ToolboxDisableItem/ToolboxEnableItem/ToolboxGetItemState
#define		TF_BYCOMMAND				0x0000
#define		TF_BYPOSITION				0x0400

#define		TF_ENABLED          0x0001
#define		TF_SELECTED					0x0002
#define		TF_DISABLED        	0x0003

//          T o o l b o x   S y s t e m   M e n u
// ----------------------------------------------------------------------
// most items on the toolbox menu will call
// some cmacw macro for handling
// this structure will be passed with the call to ToolboxCreate

#DEFINE PtbSysMenuInfo POINTER
struct TtbSysMenuInfo
{
	// checkmark shows current orientation
	int wTBmgrLeft;
	int wTBmgrRight;
	int wTBmgrTop;
	int wTBmgrBottom;
	int wTBmgrFloating;
	int wTBmgrRoving;

	// checkmark show current icon size
	int wTBmgrBigIcon;
	int wTBmgrSmallIcon;

	int wTBmgrShowTbox;         // Show...   hide/show from a list
	int wTBmgrHide;             // Hide current toolbox

	int wTBmgrEdit;             // edit toolbox attached to current menu
	int wTbmgrWcmd;             // just bring up the toolbox manager

	int wTbmgrCheckmarks;

}

//***************************************************************
// Tool box functions
//***************************************************************
IMPORT  BOOL  ToolboxSetPopupDelay(dword wDelay)
                  MEWTLS32 "ToolboxSetPopupDelay";
IMPORT  BOOL  ToolboxGetTitle(HWND hwin, *ASCIIZ title)
                  MEWTLS32 "ToolboxGetTitle";
IMPORT  BOOL  ToolboxSetTitle(HWND hwin, ASCIIZ title)
                  MEWTLS32 "ToolboxSetTitle";
IMPORT  BOOL  ToolboxShow(HWND hwin)
                  MEWTLS32 "ToolboxShow";
IMPORT	BOOL	ToolboxHide(HWND hwin)
                  MEWTLS32 "ToolboxHide";
IMPORT	BOOL	ToolboxIsVisible(HWND hwin)
                  MEWTLS32 "ToolboxIsVisible";
IMPORT  BOOL  ToolboxIsFloating(HWND hwin)
                  MEWTLS32 "ToolboxIsFloating";
IMPORT	dword	ToolboxCreate(HWND hwin,ASCIIZ lpszTitle,dword wWndStyle,dword wXSize,
								dword wYSize,dword hMDIClient,
								PTBSYSMENUINFO ts)
                  MEWTLS32 "ToolboxCreate";
IMPORT	dword	ToolboxSetFont(HWND hwin,dword wWeight,dword wMaxHeight,ASCIIZ lpszFaceName)
                  MEWTLS32 "ToolboxSetFont";
IMPORT	dword	ToolboxAddBitmapItem(HWND hwin,dword hBMSrc,dword wXPos,dword wId,dword wStyle,
									ASCIIZ lpszQHelpText,ASCIIZ lpszEHelpLink)
                  MEWTLS32 "ToolboxAddBitmapItem";
IMPORT	dword	ToolboxAddTextItem(HWND hwin,ASCIIZ lpszText,dword wId,dword wStyle,ASCIIZ lpszQHelpText,
									ASCIIZ lpszEHelpLink)
                  MEWTLS32 "ToolboxAddTextItem";
IMPORT	dword	ToolboxSetPos(HWND hwin,dword wXCoord,dword wYCoord)
                  MEWTLS32 "ToolboxSetPos";
IMPORT 	dword	ToolboxDisableItem(HWND hwin,dword wItemId,dword wFlag,dword wRedraw)
                  MEWTLS32 "ToolboxDisableItem";
IMPORT  dword	ToolboxEnableItem(HWND hwin,dword wItemId,dword wFlag,dword wRedraw)
                  MEWTLS32 "ToolboxEnableItem";
IMPORT	dword	ToolboxGetItemState(HWND hwin,dword wItemId,dword wFlag,dword wRedraw)
                  MEWTLS32 "ToolboxGetItemState";
IMPORT	dword	ToolboxSetItemState(HWND hwin,dword wItemId,dword wFlag,dword wState,dword wRedraw)
                  MEWTLS32 "ToolboxSetItemState";
IMPORT  dword  ToolboxGetItemId(HWND hwin, dword wItemNum)
                  MEWTLS32 "ToolboxGetItemId";
IMPORT	dword 	ToolboxGetItemCount(HWND hwin)
                  MEWTLS32 "ToolboxGetItemCount";
IMPORT	dword	ToolboxGetMenu(HWND hwin)
                  MEWTLS32 "ToolboxGetMenu";

//***************************************************************
// Quick Help popup functions
//***************************************************************
IMPORT  dword  QHelpPopup(dword ScreenX,dword ScreenYHi,dword ScreenYLo,dword iTBorientation,dword iTBitemWidth,ASCIIZ lpszQHelpText,
								ASCIIZ lpszEHelpLink)
                MEWTLS32 "QHelpPopup";
