/******************************************************************************
														Multi-Edit Header File
															 01-May-97  00:38

	Function: Win32 APIs
	Author  : Dan Hughes

	$Header: /Me9/SH/WIN32.SH 60    1/28/99 2:36p Johnp $

							 Copyright (C) 1997 by American Cybernectics, Inc.
 *******************************************************************( ldh )***/

#define   GetMajorVersion32   ( GetVersion( ) & 0xFF )
#define   MakeIntResource

#define   Bool        int

#define   THandle     int

#define   TColorRef   int


#define   HGlobal     THandle
#define   HLocal      THandle

#define   HWnd        THandle
#define   HStr        THandle
#define   HIcon       THandle
#define   HDC         THandle
#define   HMenu       THandle
#define   HPen        THandle
#define   HFont       THandle
#define   HBrush      THandle
#define   HBitmap     THandle
#define   HCursor     THandle
#define   HRgn        THandle
#define   HPalette    THandle

#define   HGDIObj     THandle
#define   HAccel      THandle
#define   HColorSpace THandle
//#define   HGLRC       THandle
#define   HDesk       THandle
//#define   HENHMETAFILE  THandle
//#define   HMETAFILE   THandle
#define   HInst       THandle
#define   HModule     HInst             // HMODULEs can be used in place of HINSTs
#define   HRsrc       THandle
#define   HTask       THandle
//#define   HKL         THandle

/* WM_NCHITTEST return codes */
#define HTERROR             ( -2 )
#define HTTRANSPARENT       ( -1 )
#define HTNOWHERE           0
#define HTCLIENT            1
#define HTCAPTION           2
#define HTSYSMENU           3
#define HTSIZE              4
#define HTMENU              5
#define HTHSCROLL           6
#define HTVSCROLL           7
#define HTMINBUTTON         8
#define HTMAXBUTTON         9
#define HTLEFT              10
#define HTRIGHT             11
#define HTTOP               12
#define HTTOPLEFT           13
#define HTTOPRIGHT          14
#define HTBOTTOM            15
#define HTBOTTOMLEFT        16
#define HTBOTTOMRIGHT       17
#define HTBORDER            18
#define HTGROWBOX           HTSIZE
#define HTREDUCE            HTMINBUTTON
#define HTZOOM              HTMAXBUTTON



#define   _TPoint   int X; int Y
#define   PPoint    Pointer
structure TPoint {
	int	X;
  int Y;
}

#define   _PRect  Pointer
#define   _TRect  int Left; int Top; int Right; int Bottom

#define   PRect   Pointer
structure TRect {
	int Left;
	int Top;
	int Right;
	int Bottom;
}

// Global Memory Flags

#define   gmem_Fixed            0
#define   gmem_Moveable         2
#define   gmem_NoCompact        0x10
#define   gmem_NoDiscard        0x20
#define   gmem_ZeroInit         0x40
#define   gmem_Modify           0x80
#define   gmem_Discardable      0x100
#define   gmem_Not_Banked       0x1000
#define   gmem_Share            0x2000
#define   gmem_DDEShare         0x2000
#define   gmem_Notify           0x4000
#define   gmem_Lower            gmem_Not_Banked
#define   gmem_Valid_Flags      32626
#define   gmem_Invalid_Handle   0x8000

#define   ghnd                  gmem_Moveable | gmem_ZeroInit
#define   gptr                  gmem_Fixed | gmem_ZeroInit


structure NMHDR {
  HWND hwndFrom;
  int idFrom;
  int code;
}

// Predefined Resource Types
#define   rt_Cursor         1
#define   rt_Bitmap         2
#define   rt_Icon           3
#define   rt_Menu           4
#define   rt_Dialog         5
#define   rt_String         6
#define   rt_FontDir        7
#define   rt_Font           8
#define   rt_Accelerator    9
#define   rt_RCData         10

#define   difference        11

#define   rt_Group_Cursor   rt_Cursor + difference
#define   rt_Group_Icon     rt_Icon + difference
#define   rt_Version        16
#define   rt_DlgInclude     17
#define   rt_PlugPlay       19
#define   rt_VXD            20

// Bitmap Header Definition
#define   PBitmap   Pointer
structure TBitmap {
	int   bmType;
	int   bmWidth;
	int   bmHeight;
	int   bmWidthBytes;
	Word	bmPlanes;
	Word  bmBitsPixel;
	int   bmBits;
	// Pointer bmBits;  Pointer isn't supported thus we use LongInt
}


// Message structure
#define   PMsg    Pointer
structure TMsg {
	HWnd			hWnd;
	int				Message;
	int				WParam;
	int				LParam;
	int				Time;
	_TPoint;
//	TPoint	pt;
}

// DrawText Format Flags
#define   dt_Top              0x0000
#define   dt_Left             0x0000
#define   dt_Center           0x0001
#define   dt_Right            0x0002
#define   dt_VCenter          0x0004
#define   dt_Bottom           0x0008
#define   dt_WordBreak        0x0010
#define   dt_SingleLine       0x0020
#define   dt_ExpandTabs       0x0040
#define   dt_TabStop          0x0080
#define   dt_NoClip           0x0100
#define   dt_ExternalLeading  0x0200
#define   dt_CalcRect         0x0400
#define   dt_NoPrefix         0x0800
#define   dt_Internal         0x1000

#define   dt_EditControl      0x2000
#define   dt_Path_Ellipsis    0x4000
#define   dt_End_Ellipsis     0x8000
#define   dt_ModifyString     0x10000
#define   dt_RTLReading       0x20000
#define   dt_Word_Ellipsis    0x40000


// Scroll Bar Constants
#define   sb_Horz             0
#define   sb_Vert             1
#define   sb_Ctl              2
#define   sb_Both             3

// Scroll Bar Commands
#define   sb_LineUp           0
#define   sb_LineLeft         0
#define   sb_LineDown         1
#define   sb_LineRight        1
#define   sb_PageUp           2
#define   sb_PageLeft         2
#define   sb_PageDown         3
#define   sb_PageRight        3
#define   sb_ThumbPosition    4
#define   sb_ThumbTrack       5
#define   sb_Top              6
#define   sb_Left             6
#define   sb_Bottom           7
#define   sb_Right            7
#define   sb_EndScroll        8

// ShowWindow( ) Commands
#define   sw_Hide             0
#define   sw_ShowNormal       1
#define   sw_Normal           1
#define   sw_ShowMinimized    2
#define   sw_ShowMaximized    3
#define   sw_Maximize         3
#define   sw_ShowNoActivate   4
#define   sw_Show             5
#define   sw_Minimize         6
#define   sw_ShowMinNoActive  7
#define   sw_ShowNA           8
#define   sw_Restore          9
#define   sw_ShowDefault      10
#define   sw_Max              10

// Identifiers for the wm_ShowWindow message
#define   sw_ParentClosing    1
#define   sw_OtherZoom        2
#define   sw_ParentOpening    3
#define   sw_OtherUnzoom      4

// Virtual Keys, Standard Set
#define   VK_LBUTTON      1
#define   VK_RBUTTON      2
#define   VK_CANCEL       3
#define   VK_MBUTTON      4  // NOT contiguous with L & RBUTTON
#define   VK_BACK         8
#define   VK_TAB          9
#define   VK_CLEAR        12
#define   VK_RETURN       13
#define   VK_SHIFT        0x10
#define   VK_CONTROL      17
#define   VK_MENU         18
#define   VK_PAUSE        19
#define   VK_CAPITAL      20
#define   VK_ESCAPE       27
#define   VK_SPACE        0x20
#define   VK_PRIOR        33
#define   VK_NEXT         34
#define   VK_END          35
#define   VK_HOME         36
#define   VK_LEFT         37
#define   VK_UP           38
#define   VK_RIGHT        39
#define   VK_DOWN         40
#define   VK_SELECT       41
#define   VK_PRINT        42
#define   VK_EXECUTE      43
#define   VK_SNAPSHOT     44
#define   VK_INSERT       45
#define   VK_DELETE       46
#define   VK_HELP         47
// VK_0 thru VK_9 are the same as ASCII '0' thru '9' ( $30 - $39 )
// VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' ( $41 - $5A )
#define   VK_LWIN         91
#define   VK_RWIN         92
#define   VK_APPS         93
#define   VK_NUMPAD0      96
#define   VK_NUMPAD1      97
#define   VK_NUMPAD2      98
#define   VK_NUMPAD3      99
#define   VK_NUMPAD4      100
#define   VK_NUMPAD5      101
#define   VK_NUMPAD6      102
#define   VK_NUMPAD7      103
#define   VK_NUMPAD8      104
#define   VK_NUMPAD9      105
#define   VK_MULTIPLY     106
#define   VK_ADD          107
#define   VK_SEPARATOR    108
#define   VK_SUBTRACT     109
#define   VK_DECIMAL      110
#define   VK_DIVIDE       111
#define   VK_F1           112
#define   VK_F2           113
#define   VK_F3           114
#define   VK_F4           115
#define   VK_F5           116
#define   VK_F6           117
#define   VK_F7           118
#define   VK_F8           119
#define   VK_F9           120
#define   VK_F10          121
#define   VK_F11          122
#define   VK_F12          123
#define   VK_F13          124
#define   VK_F14          125
#define   VK_F15          126
#define   VK_F16          127
#define   VK_F17          128
#define   VK_F18          129
#define   VK_F19          130
#define   VK_F20          131
#define   VK_F21          132
#define   VK_F22          133
#define   VK_F23          134
#define   VK_F24          135
#define   VK_NUMLOCK      144
#define   VK_SCROLL       145
// VK_L & VK_R - left and right Alt, Ctrl and Shift virtual keys.
// Used only as parameters to GetAsyncKeyState( ) and GetKeyState( ).
// No other API or message will distinguish left and right keys in this way.
#define   VK_LSHIFT       160
#define   VK_RSHIFT       161
#define   VK_LCONTROL     162
#define   VK_RCONTROL     163
#define   VK_LMENU        164
#define   VK_RMENU        165
#define   VK_PROCESSKEY   229
#define   VK_ATTN         246
#define   VK_CRSEL        247
#define   VK_EXSEL        248
#define   VK_EREOF        249
#define   VK_PLAY         250
#define   VK_ZOOM         251
#define   VK_NONAME       252
#define   VK_PA1          253
#define   VK_OEM_CLEAR    254

// Key State Masks for Mouse Messages
#define   mk_LButton    0x0001
#define   mk_RButton    0x0002
#define   mk_Shift      0x0004
#define   mk_Control    0x0008
#define   mk_MButton    0x0010

// Window Styles
#define   ws_Overlapped     0x00000000
#define   ws_Popup          0x80000000
#define   ws_Child          0x40000000
#define   ws_Minimize       0x20000000
#define   ws_Visible        0x10000000
#define   ws_Disabled       0x08000000
#define   ws_ClipSiblings   0x04000000
#define   ws_ClipChildren   0x02000000
#define   ws_Maximize       0x01000000
#define   ws_Caption        0x00C00000    // ws_Border + ws_DlgFrame
#define   ws_Border         0x00800000
#define   ws_DlgFrame       0x00400000
#define   ws_VScroll        0x00200000
#define   ws_HScroll        0x00100000
#define   ws_SysMenu        0x00080000
#define   ws_ThickFrame     0x00040000
#define   ws_Group          0x00020000
#define   ws_TabStop        0x00010000

#define   ws_MinimizeBox    0x00020000
#define   ws_MaximizeBox    0x00010000

#define   ws_Tiled          ws_Overlapped
#define   ws_Iconic         ws_Minimize
#define   ws_SizeBox        ws_ThickFrame

// Common Window Styles
#define   ws_OverlappedWindow   ws_Overlapped + ws_Caption + ws_SysMenu + ws_ThickFrame + ws_MinimizeBox + ws_MaximizeBox
#define   ws_TiledWindow        ws_OverlappedWindow
#define   ws_PopupWindow        ws_Popup + ws_Border + ws_SysMenu
#define   ws_ChildWindow        ws_Child


// Extended Window Styles
#define   ws_ex_DlgModalFrame   0x00000001
#define   ws_ex_NoParentNotify  0x00000004
#define   ws_ex_TopMost         0x00000008     //Imported from WIN31.SH
#define   ws_ex_AcceptFiles     0x00000010     //Imported from WIN31.SH
#define   ws_ex_Transparent     0x00000020     //Imported from WIN31.SH
#define   WS_EX_MDICHILD        0x40
#define   WS_EX_TOOLWINDOW      0x80
#define   WS_EX_WINDOWEDGE      0x100
#define   WS_EX_CLIENTEDGE      0x200
#define   WS_EX_CONTEXTHELP     0x400

#define   WS_EX_RIGHT           0x1000
#define   WS_EX_LEFT            0x0
#define   WS_EX_RTLREADING      0x2000
#define   WS_EX_LTRREADING      0x0
#define   WS_EX_LEFTSCROLLBAR   0x4000
#define   WS_EX_RIGHTSCROLLBAR  0x0

#define   WS_EX_CONTROLPARENT   0x10000
#define   WS_EX_STATICEDGE      0x20000
#define   WS_EX_APPWINDOW       0x40000
#define   WS_EX_OVERLAPPEDWINDOW ( WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE )
#define   WS_EX_PALETTEWINDOW ( WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW or WS_EX_TOPMOST )


// Class styles
#define   cs_VRedraw          0x0001
#define   cs_HRedraw          0x0002
#define   cs_KeyCvtWindow     0x0004
#define   cs_DblClks          0x0008
#define   cs_OwnDC            0x0020
#define   cs_ClassDC          0x0040
#define   cs_ParentDC         0x0080
#define   cs_NoKeyCvt         0x0100
#define   cs_NoClose          0x0200
#define   cs_SaveBits         0x0800
#define   cs_ByteAlignClient  0x1000
#define   cs_ByteAlignWindow  0x2000
#define   cs_GlobalClass      0x4000   // Global window class

// Predefined Clipboard Formats
#define  cf_Text              1
#define  cf_Bitmap            2
#define  cf_MetafilePict      3
#define  cf_Sylk              4
#define  cf_Dif               5
#define  cf_Tiff              6
#define  cf_OemText           7
#define  cf_Dib               8
#define  cf_Palette           9
#define  cf_PenData           10
#define  cf_Riff              11
#define  cf_Wave              12
#define  cf_UnicodeText       13
#define  cf_EnhMetafile       14
#define  cf_HDrop             15
#define  cf_Locale            0x10
#define  cf_Max               17

#define  cf_OwnerDisplay      128
#define  cf_DspText           129
#define  cf_DspBitmap         130
#define  cf_DspMetafilePict   131
#define  cf_DspEnhMetafile    142

// "Private" formats don't get GlobalFree( )'d
#define  cf_PrivateFirst      0x200
#define  cf_PrivateLast       767

// "GDIOBJ" formats do get DeleteObject( )'d
#define  cf_GdiObjFirst       768
#define  cf_GdiObjLast        1023

// GetDriveType return values
#define   DRIVE_UNKNOWN       0
#define   DRIVE_NO_ROOT_DIR   1
#define   DRIVE_REMOVABLE     2
#define   DRIVE_FIXED         3
#define   DRIVE_REMOTE        4
#define   DRIVE_CDROM         5
#define   DRIVE_RAMDISK       6

import DWord  GetDriveType( Asciiz RootPath )
    kernel32 'GetDriveTypeA';


// wm_Activate state values

#define   wa_Inactive 0
#define   wa_Active 1
#define   wa_ClickActive 2

// #define PKeyboardState *TKeyboardState
#define PKeyboardState Pointer
structure TKeyboardState {
	Byte K[ 256 ];
}

import Bool   GetKeyboardState( PKeyboardState KeyState )
		user32 'GetKeyboardState';

import Bool   SetKeyboardState( PKeyboardState KeyState )
		user32 'SetKeyboardState';

import DWord  ToAscii(
    DWord   VirtKey,
    DWord   ScanCode,
    Pointer KeyState,
    Pointer cx,
    DWord   Flags
    )  user32 'ToAscii';

import DWord MapVirtualKey( DWord Code, DWord MapType )
		user32 'MapVirtualKeyA';

import int  GetKeyState( int VirtKey )
		user32 'GetKeyState';

#define KEYEVENTF_EXTENDEDKEY   1
#define KEYEVENTF_KEYUP         2

import void   Keybd_Event(
    Byte  bVk,
    Byte  bScan,
    DWord dwFlags,
    DWord dwExtraInfo
    )  user32 'keybd_event';

import Bool   KillTimer( HWnd Wnd, int IDEvent )
    user32 'KillTimer';

import DWord  SetTimer( HWnd Wnd, int IDEvent, int Elapse, int TimerFunc )
    user32 'SetTimer';


#define   PPaintStruct    Pointer
structure TPaintStruct {
	HDC	 	hDC;
  Bool  fErase;
	_TRect;
//  TRect rcPaint;  NOT YET SUPPORTED, SEE ABOVE
  Bool  fRestore;
  Bool  fIncUpdate;
	Byte 	rgbReserved[ 32 ];
}


// TDrawItemStruct for ownerdraw
//#define PDrawItemStruct   *TDrawItemStruct
#define PDrawItemStruct   Pointer
structure TDrawItemStruct {
    int   CtlType;
    int   CtlID;
    int   itemID;
    int   itemAction;
    int   itemState;
    HWnd  hwndItem;
    HDC   hDC;
    _TRect;
    int   itemData;  //was LongInt but it's not supported, thus we use int
}

// wm_WindowPosChangingChanged struct pointed to by LParam
#define PWindowPos  Pointer
structure TWindowPos {
  HWnd  Wnd;
  HWnd  WndInsertAfter;
  int   x;
  int   y;
  int   cx;
  int   cy;
  int   flags;
}


#define   odt_Menu     1
#define   odt_ListBox  2
#define   odt_ComboBox 3
#define   odt_Button   4

// Owner draw actions


#define   oda_DrawEntire 0x0001
#define   oda_Select     0x0002
#define   oda_Focus      0x0004

// Owner draw state


#define   ods_Selected 0x0001
#define   ods_Grayed   0x0002
#define   ods_Disabled 0x0004
#define   ods_Checked  0x0008
#define   ods_Focus    0x0010
#define   ODS_DEFAULT  0x0020

// SetWindowPos Flags
#define   swp_NoSize          1
#define   swp_NoMove          2
#define   swp_NoZOrder        4
#define   swp_NoRedraw        8
#define   swp_NoActivate      0x10
#define   swp_FrameChanged    0x20      // The frame changed: send WM_NCCALCSIZE
#define   swp_ShowWindow      0x40
#define   swp_HideWindow      0x80
#define   swp_NoCopyBits      0x100
#define   swp_NoOwnerZOrder   0x200     // Don't do owner Z ordering
#define   swp_NoSendChanging  0x400     // Don't send WM_WINDOWPOSCHANGING
#define   swp_DrawFrame       swp_FrameChanged
#define   swp_NoReposition    Swp_NoOwnerZOrder
#define   swp_DeferErase      0x2000
#define   swp_ASYNCWINDOWPOS  0x4000

#define   hwnd_Top            0
#define   hwnd_Bottom         1
#define   hwnd_TopMost        -1
#define   hwnd_NoTopMost      -2


// PeekMessage Options
#define   pm_NoRemove   0x0000
#define   pm_Remove     0x0001
#define   pm_NoYield    0x0002

// MessageBox( ) Flags
#define   mb_Ok               0x0000
#define   mb_OkCancel         0x0001
#define   mb_AbortRetryIgnore 0x0002
#define   mb_YesNoCancel      0x0003
#define   mb_YesNo            0x0004
#define   mb_RetryCancel      0x0005

#define   mb_IconHand         0x0010
#define   mb_IconQuestion     0x0020
#define   mb_IconExclamation  0x0030
#define   mb_IconAsterisk     0x0040

#define   mb_IconWarning      mb_IconExclamation
#define   mb_IconError        mb_IconHand
#define   mb_IconInformation  mb_IconAsterisk
#define   mb_IconStop         mb_IconHand

#define   mb_DefButton1       0x0000
#define   mb_DefButton2       0x0100
#define   mb_DefButton3       0x0200
#define   mb_DefButton4       0x0300

#define   mb_ApplModal        0x0000
#define   mb_SystemModal      0x1000
#define   mb_TaskModal        0x2000
#define   mb_Help             0x4000    // Help button

#define   mb_NoFocus          0x8000

#define   mb_TypeMask         0x000F
#define   mb_UserIcon         0x0080
#define   mb_IconMask         0x00F0
#define   mb_DefMask          0x0F00
#define   mb_ModeMask         0x3000
#define   mb_MiscMask         0xC000

// Color Types
#define   ctlcolor_MsgBox       0
#define   ctlcolor_Edit         1
#define   ctlcolor_ListBox      2
#define   ctlcolor_Btn          3
#define   ctlcolor_Dlg          4
#define   ctlcolor_ScrollBar    5
#define   ctlcolor_Static       6
#define   ctlcolor_Max          7

#define   color_ScrollBar       0
#define   color_Background      1
#define   color_ActiveCaption   2
#define   color_InactiveCaption 3
#define   color_Menu            4
#define   color_Window          5
#define   color_WindowFrame     6
#define   color_MenuText        7
#define   color_WindowText      8
#define   color_CaptionText     9
#define   color_ActiveBorder    10
#define   color_InactiveBorder  11
#define   color_AppWorkSpace    12
#define   color_Highlight       13
#define   color_HighlightText   14
#define   color_BtnFace         15
#define   color_BtnShadow       16
#define   color_GrayText        17
#define   color_BtnText         18

// the constant below was COLOR_INACTIVECAPTIONTEXT but conflicted with the
// constant COLOR_INACTIVECAPTION so we changed it a bit.
#define   color_InactiveTextCaption 19
#define   color_BtnHighlight        20

#define   color_3DDkShadow      21
#define   color_3DLight         22
#define   color_InfoText        23
#define   color_InfoBk          24
#define   color_EndColors       color_InfoBk
#define   color_Desktop         color_Background
#define   color_3DFace          color_BtnFace
#define   color_3DShadow        color_BtnShadow
#define   color_3DHighlight     color_BtnHighlight
#define   color_3DHilight       color_BtnHighlight
#define   color_BtnHilight      color_BtnHighlight

// GetWindow( ) Constants
#define   gw_HWndFirst  0
#define   gw_HWndLast   1
#define   gw_HWndNext   2
#define   gw_HWndPrev   3
#define   gw_Owner      4
#define   gw_Child      5
#define   gw_Max        5

// System Menu Command Values
#define   sc_Size           61440
#define   sc_Move           61456
#define   sc_Minimize       61472
#define   sc_Maximize       61488
#define   sc_NextWindow     61504
#define   sc_PrevWindow     61520
#define   sc_Close          61536
#define   sc_VScroll        61552
#define   sc_HScroll        61568
#define   sc_MouseMenu      61584
#define   sc_KeyMenu        61696
#define   sc_Arrange        61712
#define   sc_Restore        61728
#define   sc_TaskList       61744
#define   sc_ScreenSave     61760
#define   sc_HotKey         61776
#define   sc_Default        61792
#define   sc_MonitorPower   61808
#define   sc_ContextHelp    61824
#define   sc_Separator      61455

// Obsolete names
#define   sc_Icon           sc_Minimize
#define   sc_Zoom           sc_Maximize

// Dialog Box Command IDs
#define   idOk        1
#define   idCancel    2
#define   idAbort     3
#define   idRetry     4
#define   idIgnore    5
#define   idYes       6
#define   idNo        7
#define   idClose     8
#define   idHelp      9


#define   id_Ok       idOk
#define   id_Cancel   idCancel
#define   id_Abort    idAbort
#define   id_Retry    idRetry
#define   id_Ignore   idIgnore
#define   id_Yes      idYes
#define   id_No       idNo
#define   id_Close    idClose
#define   id_Help     idHelp

// Control Manager Structures and Definitions

// Edit Control Styles
#define   es_Left           0x0000
#define   es_Center         0x0001
#define   es_Right          0x0002
#define   es_MultiLine      0x0004
#define   es_UpperCase      0x0008
#define   es_LowerCase      0x0010
#define   es_Password       0x0020
#define   es_AutoVScroll    0x0040
#define   es_AutoHScroll    0x0080
#define   es_NoHideSel      0x0100
#define   es_OEMConvert     0x0400
#define   es_ReadOnly       0x0800
#define   es_WantReturn     0x1000
#define   es_Number         0x2000

// Button Control Styles
#define   bs_PushButton       0x00
#define   bs_DefPushButton    0x01
#define   bs_CheckBox         0x02
#define   bs_AutoCheckBox     0x03
#define   bs_RadioButton      0x04
#define   bs_3State           0x05
#define   bs_Auto3State       0x06
#define   bs_GroupBox         0x07
#define   bs_UserButton       0x08
#define   bs_AutoRadioButton  0x09
//#define   bs_PushBox          0x0A
#define   bs_OwnerDraw        0x0B
#define   bs_LeftText         0x20

// Static Control Constants
#define   ss_Left             0x00
#define   ss_Center           0x01
#define   ss_Right            0x02
#define   ss_Icon             0x03
#define   ss_BlackRect        0x04
#define   ss_GrayRect         0x05
#define   ss_WhiteRect        0x06
#define   ss_BlackFrame       0x07
#define   ss_GrayFrame        0x08
#define   ss_WhiteFrame       0x09
#define   ss_UserItem         0x0A
#define   ss_Simple           0x0B
#define   ss_LeftNoWordWrap   0x0C
#define   ss_Bitmap           14
#define   ss_OwnerDraw        13
#define   ss_EnhMetaFile      15
#define   ss_EtchedHorz       0x10
#define   ss_EtchedVert       17
#define   ss_EtchedFrame      18
#define   ss_TypeMask         31
#define   ss_NoPrefix         0x80      // Don't do '&' character translation
#define   ss_Notify           0x100
#define   ss_CenterImage      0x200
#define   ss_RightJust        0x400
#define   ss_RealSizeImage    0x800
#define   ss_Sunken           0x1000

// Dialog Styles
#define   ds_AbsAlign         1
#define   ds_SysModal         2
#define   ds_LocalEdit        0x20      // Edit items get Local storage.
#define   ds_SetFont          0x40      // User specified font for Dlg controls
#define   ds_ModalFrame       0x80      // Can be combined with WS_CAPTION
#define   ds_NoIdleMsg        0x100     // WM_ENTERIDLE message will not be sent
#define   ds_SetForeground    0x200     // not in win3.1

#define   DS_3DLOOK           4
#define   DS_FIXEDSYS         8
#define   DS_NOFAILCREATE     0x10
#define   DS_CONTROL          0x400
#define   DS_CENTER           0x800
#define   DS_CENTERMOUSE      0x1000
#define   DS_CONTEXTHELP      0x2000

#define   PSI_SETACTIVE       1
#define   PSI_KILLACTIVE      2
#define   PSI_APPLY           3
#define   PSI_RESET           4
#define   PSI_HASHELP         5
#define   PSI_HELP            6

#define   PSI_CHANGED         1
#define   PSI_GUISTART        2
#define   PSI_REBOOT          3
#define   PSI_GETSIBLINGS     4

// Returned in HiWord( ) of DM_GETDEFID result if msg is supported
#define   DC_HASDEFID         21323

// Dialog Codes
#define   DLGC_WANTARROWS       1       // Control wants arrow keys
#define   DLGC_WANTTAB          2       // Control wants tab keys
#define   DLGC_WANTALLKEYS      4       // Control wants all keys
#define   DLGC_WANTMESSAGE      4       // Pass message to control
#define   DLGC_HASSETSEL        8       // Understands EM_SETSEL message
#define   DLGC_DEFPUSHBUTTON    0x10    // Default pushbutton
#define   DLGC_UNDEFPUSHBUTTON  0x20    // Non-default pushbutton
#define   DLGC_RADIOBUTTON      0x40    // Radio button
#define   DLGC_WANTCHARS        0x80    // Want WM_CHAR messages
#define   DLGC_STATIC           0x100   // Static item: don't include
#define   DLGC_BUTTON           0x2000  // Button item: can be checked
#define   LB_CTLCODE            0

// Listbox Return Values
#define   LB_OKAY               0
#define   LB_ERR                -1
#define   LB_ERRSPACE           -2

// Listbox Styles
#define   LBS_NOTIFY            1
#define   LBS_SORT              2
#define   LBS_NOREDRAW          4
#define   LBS_MULTIPLESEL       8
#define   LBS_OWNERDRAWFIXED    0x10
#define   LBS_OWNERDRAWVARIABLE 0x20
#define   LBS_HASSTRINGS        0x40
#define   LBS_USETABSTOPS       0x80
#define   LBS_NOINTEGRALHEIGHT  0x100
#define   LBS_MULTICOLUMN       0x200
#define   LBS_WANTKEYBOARDINPUT 0x400
#define   LBS_EXTENDEDSEL       0x800
#define   LBS_DISABLENOSCROLL   0x1000
#define   LBS_NODATA            0x2000
#define   LBS_NOSEL             0x4000
#define   LBS_STANDARD  ( LBS_NOTIFY or LBS_SORT or WS_VSCROLL or WS_BORDER )

// Combo Box return Values
#define   CB_OKAY               0
#define   CB_ERR                -1
#define   CB_ERRSPACE           -2

// Combo Box styles
#define   CBS_SIMPLE            1
#define   CBS_DROPDOWN          2
#define   CBS_DROPDOWNLIST      3
#define   CBS_OWNERDRAWFIXED    0x10
#define   CBS_OWNERDRAWVARIABLE 0x20
#define   CBS_AUTOHSCROLL       0x40
#define   CBS_OEMCONVERT        0x80
#define   CBS_SORT              0x100
#define   CBS_HASSTRINGS        0x200
#define   CBS_NOINTEGRALHEIGHT  0x400
#define   CBS_DISABLENOSCROLL   0x800
#define   CBS_UPPERCASE         0x2000
#define   CBS_LOWERCASE         0x4000

// Scroll Bar Styles
#define   SBS_HORZ                      0
#define   SBS_VERT                      1
#define   SBS_TOPALIGN                  2
#define   SBS_LEFTALIGN                 2
#define   SBS_BOTTOMALIGN               4
#define   SBS_RIGHTALIGN                4
#define   SBS_SIZEBOXTOPLEFTALIGN       2
#define   SBS_SIZEBOXBOTTOMRIGHTALIGN   4
#define   SBS_SIZEBOX                   8
#define   SBS_SIZEGRIP                  0x10

#define   SIF_RANGE             1
#define   SIF_PAGE              2
#define   SIF_POS               4
#define   SIF_DISABLENOSCROLL   8
#define   SIF_TRACKPOS          0x10
#define   SIF_ALL         ( SIF_RANGE or SIF_PAGE or SIF_POS or SIF_TRACKPOS)

// Background Modes
#define   transparent   1
#define   opaque        2
#define   bkMode_Last   2

// RedrawWindow( )
#define   rdw_Invalidate      1
#define   rdw_InternalPaint   2
#define   rdw_Erase           4
#define   rdw_Validate        8
#define   rdw_NoInternalPaint 0x10
#define   rdw_NoErase         0x20
#define   rdw_NoChildren      0x40
#define   rdw_AllChildren     0x80
#define   rdw_UpdateNow       0x100
#define   rdw_EraseNow        0x200
#define   rdw_Frame           0x400
#define   rdw_NoFrame         0x800





// Kernel32 functions

import HRsrc	FindResource( HModule Module, Asciiz Name, Asciiz ResType )
		kernel32 'FindResourceA';

import HRsrc	FindResourceP( HModule Module, Asciiz Name, DWord ResType )
		kernel32 'FindResourceA';

import Bool  FreeResource( HGlobal ResData )
		kernel32 'FreeResource';

import THandle  GetModuleHandle( Asciiz ModuleName )
    kernel32 'GetModuleHandleA';


import HGlobal GlobalAlloc( int Flags, int Bytes )
		kernel32 'GlobalAlloc';

import HGlobal GlobalFree( HGlobal hMem )
		kernel32 'GlobalFree';

import Pointer	GlobalLock( HGlobal HMem )
		kernel32 'GlobalLock';

import Bool GlobalUnlock( HGlobal hMem )
		kernel32 'GlobalUnlock';

import int GetProfileString(
		Asciiz		AppName,
		Asciiz		KeyName,
		Asciiz		Default,
		*Asciiz		ReturnedString,
		int				Size
		 ) kernel32 'GetProfileStringA';

import int	GetVersion( )
		kernel32 'GetVersion';

import HGlobal	LoadResource( HInst Module, HRsrc ResInfo )
		kernel32 'LoadResource';

import DWord  GetPrivateProfileInt(
    Asciiz ApplicationName,
    Asciiz KeyName,
    int    Default,
    Asciiz FileName
    )  kernel32 'GetPrivateProfileIntA';

import DWord  GetPrivateProfileString(
    Asciiz  ApplicationName,
    Asciiz  KeyName,
    Asciiz  Default,
    *Asciiz ReturnedString,
    DWord   Size,
    Asciiz  FileName
    )  kernel32 'GetPrivateProfileStringA';

import DWord  GetProfileInt(
    Asciiz AppName,
    Asciiz KeyName,
    int    Default
    )  kernel32 'GetProfileIntA';

import DWord  GetProfileString(
    Asciiz  AppName,
    Asciiz  KeyName,
    Asciiz  Default,
    *Asciiz ReturnedString,
    int     Size
    )  kernel32 'GetProfileStringA';

import Bool   WritePrivateProfileString(
    Asciiz ApplicationName,
    Asciiz KeyName,
    Asciiz Str,
    Asciiz FileName
    )  kernel32 'WritePrivateProfileStringA';

import Bool   WritePrivateProfileString1(
    Asciiz ApplicationName,
    Asciiz s1,
    DWord s2,
    Asciiz FileName
    )  kernel32 'WritePrivateProfileStringA';

import Bool   WritePrivateProfileString2(
    Asciiz ApplicationName,
    DWord s1,
    DWord s2,
    Asciiz FileName
    )  kernel32 'WritePrivateProfileStringA';

import Bool   WriteProfileString(
    Asciiz ApplicationName,
    Asciiz KeyName,
    Asciiz Str
    )  kernel32 'WriteProfileStringA';



// User32 functions
import HDC  BeginPaint( HWnd Wnd, PPaintStruct Paint )
		user32 'BeginPaint';

import Bool  BringWindowToTop( HWnd Wnd )
		user32 'BringWindowToTop';


import Bool ClientToScreen( HWnd Wnd, PPoint Point )
		user32 'ClientToScreen';

import HWnd	CreateWindowEx(
		int 			ExStyle,
		Asciiz		ClassName,
  	Asciiz		WindowName,
		int				Style,
		int				X,
		int				Y,
		int				Width,
		int				Height,
  	HWnd			hWndParent,
    HMenu     HMenu,
		HInst			hInstance,
		Pointer		Param
		) user32 'CreateWindowExA';

//import HWnd CreateWindow(
//    Asciiz    ClassName,
//    Asciiz    WindowName,
//    int       Style,
//    int       X,
//    int       Y,
//    int       Width,
//    int       Height,
//    HWnd      hWndParent,
//    HMenu     HMenu,
//    HInst     hInstance,
//    Pointer   Param
//    ) user32 'CreateWindowA';

import int  DefWindowProc(
    HWnd  Wnd,
    int   Msg,
    int   WParam,
    int   LParam
    )  user32 'DefWindowProcA';


import Bool  DestroyWindow( HWnd Wnd )
		user32 'DestroyWindow';

import int  DispatchMessage( PMsg Msg )
		user32 'DispatchMessageA';

import int  DrawText(
		HDC			DC,
		Asciiz	String,
		int			Count,
  	_PRect	Rect,
		int 		Format
		) user32 'DrawTextA';

import Bool EnableWindow( HWnd Wnd, Bool Enable )
		user32 'EnableWindow';

import Bool  EndPaint( HWnd Wnd, PPaintStruct Paint )
		user32 'EndPaint';

import DWord  FillRect( HDC DC, DWord Rect, HBrush Brush )
    user32 'FillRect';

import HWnd FindWindow( Asciiz ClassName, Asciiz WindowName )
    user32 'FindWindowA';

import HWnd FindWindowN( Asciiz ClassName, DWord WindowName )
    user32 'FindWindowA';

import HWnd FindWindowC( DWord ClassName, Asciiz WindowName )
    user32 'FindWindowA';


import HWnd	GetActiveWindow( )
		user32 'GetActiveWindow';

import int  GetClassName( HWnd Wnd, *Asciiz ClassName, int MaxCount )
    user32 'GetClassNameA';

import HDC	GetDC( HWnd Wnd )
		user32 'GetDC';

import HWnd	GetDlgItem( HWnd Dlg, int IdDlgItem )
		user32 'GetDlgItem';

import DWord  GetDlgCtrlID( HWnd Wnd )
    user32 'GetDlgCtrlID';


import int	GetDlgItemText(
		HWnd		Dlg,
		int			IdDlgItem,
		*Asciiz	String,
		int			MaxCount
		) user32 'GetDlgItemTextA';

import int	GetDlgItemTextPtr(
		HWnd		Dlg,
		int			IdDlgItem,
		Pointer	P,
		int			MaxCount
		) user32 'GetDlgItemTextA';

import int  GetDlgItemInt(
    HWnd    Dlg,
    int     IdDlgItem,
    *DWord  Translate,
    Bool    Signed
    ) user32 'GetDlgItemInt';


import HWnd	GetFocus( )
		user32 'GetFocus';

import Bool  GetMessage(
		PMsg	Msg,
		HWnd	Wnd,
		int 	MsgFilterMin,
		int 	MsgFilterMax
		) user32 'GetMessageA';

import int  GetMessagePos( )
    user32 'GetMessagePos';


import HWnd GetParent( HWnd Wnd )
		user32 'GetParent';

import DWord  GetSysColor( int Index )
		user32 'GetSysColor';

import HWnd GetTopWindow( HWnd Wnd )
    user32 'GetTopWindow';


import Bool GetUpdateRect( HWnd Wnd, Pointer Rect, Bool Erase )
    user32 'GetUpdateRect';

import HWnd	GetWindow( HWnd Wnd, int Cmd )
		user32 'GetWindow';

import Bool GetWindowRect( HWnd Wnd, _PRect Rect )
		user32 'GetWindowRect';

import int	GetWindowText( HWnd Wnd, *Asciiz String, int MaxCount )
		user32 'GetWindowTextA';

import Bool  InvalidateRect( HWnd Wnd, PRect Rect, Bool Erase )
		user32 'InvalidateRect';

import int	IsDlgButtonChecked( HWnd Dlg, int IdButton )
		user32 'IsDlgButtonChecked';

import Bool  IsDialogMessage( HWnd Dlg, PMsg Msg )
		user32 'IsDialogMessageA';

import Bool IsWindow( HWnd Wnd )
    user32 'IsWindow';

import Bool IsWindowEnabled( HWnd Wnd )
		user32 'IsWindowEnabled';

import HBitmap	LoadBitmap( HInst Instance, Asciiz BitmapName )
		user32 'LoadBitmapA';


import HIcon LoadIcon( THandle Instance, Asciiz IconName )
    user32 'LoadIconA';

import HIcon LoadIconInt( THandle Instance, DWord IconId )
    user32 'LoadIconA';

/*
 * Standard Cursor IDs
 */
#define idc_Arrow           MakeIntResource( 32512 )
#define idc_IBeam           MakeIntResource( 32513 )
#define idc_Wait            MakeIntResource( 32514 )
#define idc_Cross           MakeIntResource( 32515 )
#define idc_UpArrow         MakeIntResource( 32516 )
#define idc_Size            MakeIntResource( 32640 )  /* OBSOLETE: use IDC_SIZEALL */
#define idc_Icon            MakeIntResource( 32641 )  /* OBSOLETE: use IDC_ARROW */
#define idc_SizeNwse        MakeIntResource( 32642 )
#define idc_SizeNesw        MakeIntResource( 32643 )
#define idc_SizeWe          MakeIntResource( 32644 )
#define idc_SizeNs          MakeIntResource( 32645 )
#define idc_SizeAll         MakeIntResource( 32646 )
#define idc_No              MakeIntResource( 32648 ) /*not in win3.1 */
#define idc_AppStarting     MakeIntResource( 32650 ) /*not in win3.1 */
#define idc_Help            MakeIntResource( 32651 )

import int ShowCursor( Bool bShow )
    user32 'ShowCursor';

import Bool SetCursorPos( int X, int Y )
    user32 'SetCursorPos';

import HCursor SetCursor( HCursor hCursor )
    user32 'SetCursor';

import Bool GetCursorPos( Pointer lpPoint )
    user32 'GetCursorPos';

import HCursor LoadCursor( HInst hInstance, Asciiz lpCursorName )
    user32 'LoadCursorA';

import HCursor LoadCursorSystem( HInst hInstance, DWord lpCursorName )
    user32 'LoadCursorA';

  // Standard Icon IDs
#define  idi_Application    32512
#define  idi_Hand           32513
#define  idi_Question       32514
#define  idi_Exclamation    32515
#define  idi_Asterisk       32516
#define  idi_WinLogo        32517
#define  idi_Warning        idi_Exclamation
#define  idi_Error          idi_Hand
#define  idi_Information    idi_Asterisk

import Bool MessageBeep( int Type )
		user32 'MessageBeep';

import int  MessageBox(
		HWnd 		Wnd,
		Asciiz 	Text,
		Asciiz	Caption,
		int			Type
		) user32 'MessageBoxA';

import Bool MoveWindow(
		HWnd	Wnd,
		int 	X,
		int		Y,
		int		Width,
		int		Height,
    Bool  Repaint
		) user32 'MoveWindow';

import Bool  PeekMessage(
		PMsg	Msg,
		HWnd	Wnd,
		int		MsgFilterMin,
		int		MsgFilterMax,
		int		RemoveMsg
		) user32 'PeekMessageA';

import Bool PostMessage(
		HWnd	Wnd,
		int		Msg,
		int 	WParam,
		int		LParam
		) user32 'PostMessageA';

import Bool RedrawWindow(
		HWnd		Wnd,
		PRect		lprcUpdate,
		HRgn		hrgnUpdate,
		int			Flags
		) user32 'RedrawWindow';

import int RegisterWindowMessage( Asciiz Str )
		user32 'RegisterWindowMessageA';

import int	ReleaseDC( HWnd Wnd, HDC DC )
		user32 'ReleaseDC';

import Bool ScreenToClient( HWnd Wnd, PPoint Point )
		user32 'ScreenToClient';

import int	SendDlgItemMessage(
		HWnd	Dlg,
		int		IdDlgItem,
  	int		Msg,
		int		WParam,
		int		LParam
		) user32 'SendDlgItemMessageA';

// This is a modified version of SendDlgItemMessage that passes a *Asciiz
//   instead of a DWord
import int	SendDlgItemMessageStr(
		HWnd			Dlg,
		int				IdDlgItem,
  	int				Msg,
		int				WParam,
		*Asciiz		LParam
		) user32 'SendDlgItemMessageA';

import int  SendMessage(
		HWnd 	Wnd,
		int		Msg,
		int		WParam,
		int		LParam
		) user32 'SendMessageA';

import int  SendMessageStr(
		HWnd 			Wnd,
		int				Msg,
		int				WParam,
		*Asciiz		LParam
		) user32 'SendMessageA';

import HWnd	SetActiveWindow( HWnd Wnd )
		user32 'SetActiveWindow';

import Bool SetDlgItemInt(
    HWnd    Dlg,
    int     IDDlgItem,
    int     Value,
    Bool    Signed
    ) user32 'SetDlgItemInt';

import Bool  SetDlgItemText(
		HWnd		Dlg,
		int			IdDlgItem,
		Asciiz	String
		) user32 'SetDlgItemTextA';

import HWnd	 SetFocus( HWnd Wnd )
		user32 'SetFocus';

import HWnd SetParent( HWnd WndChild, HWnd WndNewParent )
		user32 'SetParent';


import Bool ShowWindow( HWND Wnd, int CmdShow )
		user32 'ShowWindow';

import Bool SetWindowPos(
		HWnd	Wnd,
		HWnd	WndInsertAfter,
  	int		X,
		int		Y,
		int		CX,
		int		CY,
		int		Flags
		) user32 'SetWindowPos';

import Bool SetWindowText( HWnd Wnd, Asciiz String )
		user32 'SetWindowTextA';

import Bool  TranslateMessage( PMsg Msg )
		user32 'TranslateMessage';

import Bool  UpdateWindow( HWnd Wnd )
		user32 'UpdateWindow';


//  Stock Logical Objects
#define WHITE_BRUSH   				0
#define LTGRAY_BRUSH    			1
#define GRAY_BRUSH    				2
#define DKGRAY_BRUSH    			3
#define BLACK_BRUSH   				4
#define NULL_BRUSH    				5
#define HOLLOW_BRUSH    		  NULL_BRUSH
#define WHITE_PEN   					6
#define BLACK_PEN   					7
#define NULL_PEN    					8
#define OEM_FIXED_FONT    		10
#define ANSI_FIXED_FONT   		11
#define ANSI_VAR_FONT   			12
#define SYSTEM_FONT   				13
#define DEVICE_DEFAULT_FONT		14
#define DEFAULT_PALETTE   		15
#define SYSTEM_FIXED_FONT   	0x10
#define DEFAULT_GUI_FONT    	17
#define STOCK_LAST    				17

#define CLR_INVALID   				0xFFFFFFFF

//  Brush Styles
#define BS_SOLID    			0
#define BS_NULL   				1
#define BS_HOLLOW   			BS_NULL
#define BS_HATCHED    		2
#define BS_PATTERN    		3
#define BS_INDEXED    		4
#define BS_DIBPATTERN   	5
#define BS_DIBPATTERNPT   6
#define BS_PATTERN8X8   	7
#define BS_DIBPATTERN8X8	8

//  Hatch Styles
#define HS_HORIZONTAL   0       //  -----
#define HS_VERTICAL     1       //  |||||
#define HS_FDIAGONAL    2       //  /////
#define HS_BDIAGONAL    3       //  \\\\\
#define HS_CROSS        4       //  +++++
#define HS_DIAGCROSS    5       //  xxxxx


//  Pen Styles
#define PS_SOLID          0
#define PS_DASH           1      //  -------
#define PS_DOT            2      //  .......
#define PS_DASHDOT        3      //  _._._._
#define PS_DASHDOTDOT     4      //  _.._.._
#define PS_NULL   				5
#define PS_INSIDEFRAME  	6
#define PS_USERSTYLE    	7
#define PS_ALTERNATE    	8
#define PS_STYLE_MASK   	15

#define PS_ENDCAP_ROUND   0
#define PS_ENDCAP_SQUARE  0x100
#define PS_ENDCAP_FLAT    0x200
#define PS_ENDCAP_MASK    3840

#define PS_JOIN_ROUND   	0
#define PS_JOIN_BEVEL   	0x1000
#define PS_JOIN_MITER   	0x2000
#define PS_JOIN_MASK    	61440

#define PS_COSMETIC   		0
#define PS_GEOMETRIC    	0x10000
#define PS_TYPE_MASK    	0xF0000

/* size of a device name string */
#define CCHDEVICENAME 32

/* size of a form name string */
#define CCHFORMNAME 32
// Devices
struct TDeviceMode {
    Asciiz  dmDeviceName[ CCHDEVICENAME ];
    Word    dmSpecVersion;
    Word    dmDriverVersion;
    Word    dmSize;
    Word    dmDriverExtra;
    int     dmFields;
    Word    dmOrientation;
    Word    dmPaperSize;
    Word    dmPaperLength;
    Word    dmPaperWidth;
    Word    dmScale;
    Word    dmCopies;
    Word    dmDefaultSource;
    Word    dmPrintQuality;
    Word    dmColor;
    Word    dmDuplex;
    Word    dmYResolution;
    Word    dmTTOption;
    Word    dmCollate;
    Asciiz  dmFormName[ CCHFORMNAME ];
    Word    dmLogPixels;
    int     dmBitsPerPel;
    int     dmPelsWidth;
    int     dmPelsHeight;
    int     dmDisplayFlags;
    int     dmDisplayFrequency;
    int     dmICMMethod;
    int     dmICMIntent;
    int     dmMediaType;
    int     dmDitherType;
    int     dmICCManufacturer;
    int     dmICCModel;
    int     dmPanningWidth;
    int     dmPanningHeight;
}
#define PDEVMODE  Pointer
#define TDEVMODE  TDeviceMode

#define DM_SPECVERSION 0x0401

/* field selection bits */
#define DM_ORIENTATION      0x00000001L
#define DM_PAPERSIZE        0x00000002L
#define DM_PAPERLENGTH      0x00000004L
#define DM_PAPERWIDTH       0x00000008L
#define DM_SCALE            0x00000010L
#define DM_COPIES           0x00000100L
#define DM_DEFAULTSOURCE    0x00000200L
#define DM_PRINTQUALITY     0x00000400L
#define DM_COLOR            0x00000800L
#define DM_DUPLEX           0x00001000L
#define DM_YRESOLUTION      0x00002000L
#define DM_TTOPTION         0x00004000L
#define DM_COLLATE          0x00008000L
#define DM_FORMNAME         0x00010000L
#define DM_LOGPIXELS        0x00020000L
#define DM_BITSPERPEL       0x00040000L
#define DM_PELSWIDTH        0x00080000L
#define DM_PELSHEIGHT       0x00100000L
#define DM_DISPLAYFLAGS     0x00200000L
#define DM_DISPLAYFREQUENCY 0x00400000L
#define DM_PANNINGWIDTH     0x00800000L
#define DM_PANNINGHEIGHT    0x01000000L
#define DM_ICMMETHOD        0x02000000L
#define DM_ICMINTENT        0x04000000L
#define DM_MEDIATYPE        0x08000000L
#define DM_DITHERTYPE       0x10000000L
#define DM_ICCMANUFACTURER  0x20000000L
#define DM_ICCMODEL         0x40000000L

/* orientation selections */
#define DMORIENT_PORTRAIT   1
#define DMORIENT_LANDSCAPE  2

/* paper selections */
#define DMPAPER_FIRST                DMPAPER_LETTER
#define DMPAPER_LETTER               1  /* Letter 8 1/2 x 11 in               */
#define DMPAPER_LETTERSMALL          2  /* Letter Small 8 1/2 x 11 in         */
#define DMPAPER_TABLOID              3  /* Tabloid 11 x 17 in                 */
#define DMPAPER_LEDGER               4  /* Ledger 17 x 11 in                  */
#define DMPAPER_LEGAL                5  /* Legal 8 1/2 x 14 in                */
#define DMPAPER_STATEMENT            6  /* Statement 5 1/2 x 8 1/2 in         */
#define DMPAPER_EXECUTIVE            7  /* Executive 7 1/4 x 10 1/2 in        */
#define DMPAPER_A3                   8  /* A3 297 x 420 mm                    */
#define DMPAPER_A4                   9  /* A4 210 x 297 mm                    */
#define DMPAPER_A4SMALL             10  /* A4 Small 210 x 297 mm              */
#define DMPAPER_A5                  11  /* A5 148 x 210 mm                    */
#define DMPAPER_B4                  12  /* B4 ( JIS ) 250 x 354                 */
#define DMPAPER_B5                  13  /* B5 ( JIS ) 182 x 257 mm              */
#define DMPAPER_FOLIO               14  /* Folio 8 1/2 x 13 in                */
#define DMPAPER_QUARTO              15  /* Quarto 215 x 275 mm                */
#define DMPAPER_10X14               16  /* 10x14 in                           */
#define DMPAPER_11X17               17  /* 11x17 in                           */
#define DMPAPER_NOTE                18  /* Note 8 1/2 x 11 in                 */
#define DMPAPER_ENV_9               19  /* Envelope #9 3 7/8 x 8 7/8          */
#define DMPAPER_ENV_10              20  /* Envelope #10 4 1/8 x 9 1/2         */
#define DMPAPER_ENV_11              21  /* Envelope #11 4 1/2 x 10 3/8        */
#define DMPAPER_ENV_12              22  /* Envelope #12 4 \276 x 11           */
#define DMPAPER_ENV_14              23  /* Envelope #14 5 x 11 1/2            */
#define DMPAPER_CSHEET              24  /* C size sheet                       */
#define DMPAPER_DSHEET              25  /* D size sheet                       */
#define DMPAPER_ESHEET              26  /* E size sheet                       */
#define DMPAPER_ENV_DL              27  /* Envelope DL 110 x 220mm            */
#define DMPAPER_ENV_C5              28  /* Envelope C5 162 x 229 mm           */
#define DMPAPER_ENV_C3              29  /* Envelope C3  324 x 458 mm          */
#define DMPAPER_ENV_C4              30  /* Envelope C4  229 x 324 mm          */
#define DMPAPER_ENV_C6              31  /* Envelope C6  114 x 162 mm          */
#define DMPAPER_ENV_C65             32  /* Envelope C65 114 x 229 mm          */
#define DMPAPER_ENV_B4              33  /* Envelope B4  250 x 353 mm          */
#define DMPAPER_ENV_B5              34  /* Envelope B5  176 x 250 mm          */
#define DMPAPER_ENV_B6              35  /* Envelope B6  176 x 125 mm          */
#define DMPAPER_ENV_ITALY           36  /* Envelope 110 x 230 mm              */
#define DMPAPER_ENV_MONARCH         37  /* Envelope Monarch 3.875 x 7.5 in    */
#define DMPAPER_ENV_PERSONAL        38  /* 6 3/4 Envelope 3 5/8 x 6 1/2 in    */
#define DMPAPER_FANFOLD_US          39  /* US Std Fanfold 14 7/8 x 11 in      */
#define DMPAPER_FANFOLD_STD_GERMAN  40  /* German Std Fanfold 8 1/2 x 12 in   */
#define DMPAPER_FANFOLD_LGL_GERMAN  41  /* German Legal Fanfold 8 1/2 x 13 in */

#define DMPAPER_LAST                DMPAPER_FANFOLD_LGL_GERMAN

#define DMPAPER_USER                256

/* bin selections */
#define DMBIN_FIRST         DMBIN_UPPER
#define DMBIN_UPPER         1
#define DMBIN_ONLYONE       1
#define DMBIN_LOWER         2
#define DMBIN_MIDDLE        3
#define DMBIN_MANUAL        4
#define DMBIN_ENVELOPE      5
#define DMBIN_ENVMANUAL     6
#define DMBIN_AUTO          7
#define DMBIN_TRACTOR       8
#define DMBIN_SMALLFMT      9
#define DMBIN_LARGEFMT      10
#define DMBIN_LARGECAPACITY 11
#define DMBIN_CASSETTE      14
#define DMBIN_FORMSOURCE    15
#define DMBIN_LAST          DMBIN_FORMSOURCE

#define DMBIN_USER          256     /* device specific bins start here */

/* print qualities */
#define DMRES_DRAFT         ( -1 )
#define DMRES_LOW           ( -2 )
#define DMRES_MEDIUM        ( -3 )
#define DMRES_HIGH          ( -4 )

/* color enable/disable for color printers */
#define DMCOLOR_MONOCHROME  1
#define DMCOLOR_COLOR       2

/* duplex enable */
#define DMDUP_SIMPLEX    1
#define DMDUP_VERTICAL   2
#define DMDUP_HORIZONTAL 3

/* TrueType options */
#define DMTT_BITMAP     1       /* print TT fonts as graphics */
#define DMTT_DOWNLOAD   2       /* download TT fonts as soft fonts */
#define DMTT_SUBDEV     3       /* substitute device fonts for TT fonts */

/* Collation selections */
#define DMCOLLATE_FALSE  0
#define DMCOLLATE_TRUE   1

/* DEVMODE dmDisplayFlags flags */

//#define DM_GRAYSCALE    0x00000001 /* This flag is no longer valid */
//#define DM_INTERLACED   0x00000002 /* This flag is no longer valid */
#define DMDISPLAYFLAGS_TEXTMODE 0x00000004

#define AD_COUNTERCLOCKWISE   1
#define AD_CLOCKWISE    			2

#define ETO_GRAYED  		1
#define ETO_OPAQUE  		2
#define ETO_CLIPPED 		4
#define ETO_RTLREADING 	0x80



// GDI32 functions
import HDC    CreateDC(
    Asciiz  lpszDriver,
    Asciiz  lpszDevice,
    Asciiz  lpszOutput,
    Pointer PDeviceMode
    ) gdi32 'CreateDCA';

import Bool   DeleteDC( HDC Dc )
    gdi32 'DeleteDC';

import HFont  CreateFont(
    int     Height,
    int     Width,
    int     Escapement,
    int     Orientation,
    int     Weight,
    int     Italic,
    int     Underline,
    int     StrikeOut,
    int     CharSet,
    int     OutputPrecision,
    int     ClipPrecision,
    int     Quality,
    int     PitchAndFamily,
    Asciiz  Facename
    )  gdi32 'CreateFontA';

import HFont  CreateFontIndirect( Pointer LogFont )
    gdi32 'CreateFontIndirectA';

import HBrush CreateSolidBrush( TColorRef Color )
    gdi32 'CreateSolidBrush';

import HDC  CreateCompatibleDC( HDC DC )
    gdi32 'CreateCompatibleDC';

import Bool  DeleteObject( HGDIObj P1 )
		gdi32 'DeleteObject';

import Bool ExtTextOut(
    HDC     DC,
    int 		X,
    int     Y,
    DWord   Options,
    Pointer Rect,
    Asciiz  Str,
    DWord 	Count,
    Pointer Dx
    ) gdi32 'ExtTextOutA';

import int	GetObject( HGDIObj P1, int P2, Pointer P3 )
		gdi32 'GetObjectA';

import THandle  GetStockObject( int Index )
		gdi32 'GetStockObject';

import int 	GetTextFace( HDC DC, int Count, *Asciiz Buffer )
		gdi32 'GetTextFaceA';

import Bool Rectangle( HDC DC, int X1, int Y1, int X2, int Y2 )
		gdi32 'Rectangle';

import HGDIObj	SelectObject( HDC DC, HGDIObj P2 )
		gdi32 'SelectObject';

import HPalette SelectPalette(
		HDC 			DC,
		HPalette	Palette,
    Bool      ForceBackground
		)  gdi32 'SelectPalette';

import int SetBkColor( HDC DC, int Color )
		gdi32 'SetBkColor';

import int  SetBkMode( HDC DC, int BkMode )
		gdi32 'SetBkMode';

import TColorRef  SetTextColor( HDC DC, TColorRef Color )
		gdi32 'SetTextColor';

// new StretchBlt( ) Modes ( simpler names )

#define   stretch_ANDScans        1
#define   stretch_ORScans         2
#define   stretch_DeleteScans     3

import DWord  SetStretchBltMode(
		HDC DC,
		DWord StretchMode
		)  gdi32 'SetStretchBltMode';

import Bool   StretchBlt(
		HDC DestDC,
		int X,
		int Y,
		int Width,
		int Height,
		HDC SrcDC,
    int XSrc,
		int YSrc,
		int SrcWidth,
		int SrcHeight,
		int Rop
		)  gdi32 'StretchBlt';

// Ternary raster operations

#define   SrcCopy     0x00CC0020  // dest = source
#define   SrcPaint    0x00EE0086  // dest = source OR dest
#define   SrcAnd      0x008800C6  // dest = source AND dest
#define   SrcInvert   0x00660046  // dest = source XOR dest
#define   SrcErase    0x00440328  // dest = source AND ( NOT dest )
#define   NotSrcCopy  0x00330008  // dest = ( NOT source )
#define   NotSrcErase 0x001100A6  // dest = ( NOT src ) AND ( NOT dest )
#define   MergeCopy   0x00C000CA  // dest = ( source AND pattern )
#define   MergePaint  0x00BB0226  // dest = ( NOT source ) OR dest
#define   PatCopy     0x00F00021  // dest = Pattern
#define   PatPaint    0x00FB0A09  // dest = DPSnoo
#define   PatInvert   0x005A0049  // dest = pattern XOR dest
#define   DstInvert   0x00550009  // dest = ( NOT dest )
#define   Blackness   0x00000042  // dest = BLACK
#define   Whiteness   0x00FF0062  // dest = WHITE

// StretchBlt modes

#define   BlackOnWhite 1
#define   WhiteOnBlack 2
#define   ColorOnColor 3




struct TSecurityAttributes {
	int nLength;
  int lpSecurityDescriptor;
  int bInheritHandle;
}

struct TProcessInfo {
	int hProcess;
  int hThread;
  int dwProcessId;
	int dwThreadId;
}


#define STARTF_USESHOWWINDOW      0x00000001
#define STARTF_USESIZE            0x00000002
#define STARTF_USEPOSITION        0x00000004
#define STARTF_USECOUNTCHARS      0x00000008
#define STARTF_USEFILLATTRIBUTE   0x00000010
#define STARTF_RUNFULLSCREEN      0x00000020
#define STARTF_FORCEONFEEDBACK    0x00000040
#define STARTF_FORCEOFFFEEDBACK   0x00000080
#define STARTF_USESTDHANDLES      0x00000100
#define STARTF_USEHOTKEY          0x00000200


struct TStartupInfo {
	int  cb;
  int  lpReserved;
  int  lpDesktop;
  int  lpTitle;
  int  dwX;
  int  dwY;
  int  dwXSize;
  int  dwYSize;
  int  dwXCountChars;
  int  dwYCountChars;
  int  dwFillAttribute;
  int  dwFlags;
  word wShowWindow;
  word cbReserved2;
  int  lpReserved2;
  int  hStdInput;
  int  hStdOutput;
  int  hStdError;
}


#define STILL_ACTIVE      0x00000103


import DWord	CreateProcess(
//		Asciiz		lpApplicationName,
		DWord 		lpApplicationName,
		Asciiz 		lpCommandLine,
  	Pointer		lpProcessAttributes,
		Pointer		lpThreadAttributes,       // PSecurityAttributes
  	DWord 		bInheritHandles,
		DWord 		dwCreationFlags,
		Pointer		lpEnvironment,
  	Asciiz 		lpCurrentDirectory,
//  	DWord 		lpCurrentDirectory,
		Pointer		lpStartupInfo, 			      // const TStartupInfo
  	Pointer 	lpProcessInformation      // TProcessInformation
		) kernel32 'CreateProcessA';

import DWord CloseHandle( DWord hObject )
		kernel32 'CloseHandle';

import DWord GetExitCodeProcess(
		DWord		hProcess,
		*DWord	lpExitCode
		) kernel32 'GetExitCodeProcess';

import DWord GetLastError( )
		kernel32 'GetLastError';


// Menu flags for AddCheckEnableMenuItem( )

#define MF_INSERT         	0
#define MF_CHANGE         	0x80
#define MF_APPEND         	0x100
#define MF_DELETE         	0x200
#define MF_REMOVE         	0x1000

#define MF_BYCOMMAND      	0
#define MF_BYPOSITION     	0x400

#define MF_SEPARATOR      	0x800

#define MF_ENABLED        	0
#define MF_GRAYED         	1
#define MF_DISABLED       	2

#define MF_UNCHECKED      	0
#define MF_CHECKED        	8
#define MF_USECHECKBITMAPS	0x200

#define MF_STRING         	0
#define MF_BITMAP         	4
#define MF_OWNERDRAW      	0x100

#define MF_POPUP          	0x10
#define MF_MENUBARBREAK   	0x20
#define MF_MENUBREAK      	0x40

#define MF_UNHILITE       	0
#define MF_HILITE         	0x80

#define MF_DEFAULT        	0x1000
#define MF_SYSMENU        	0x2000
#define MF_HELP           	0x4000
#define MF_RIGHTJUSTIFY   	0x4000

#define MF_MOUSESELECT    	0x8000

#define MFT_STRING        	MF_STRING
#define MFT_BITMAP        	MF_BITMAP
#define MFT_MENUBARBREAK  	MF_MENUBARBREAK
#define MFT_MENUBREAK     	MF_MENUBREAK
#define MFT_OWNERDRAW     	MF_OWNERDRAW
#define MFT_RADIOCHECK    	0x200
#define MFT_SEPARATOR     	MF_SEPARATOR
#define MFT_RIGHTORDER    	0x2000
#define MFT_RIGHTJUSTIFY  	MF_RIGHTJUSTIFY

// Menu flags for AddCheckEnableMenuItem( )
#define MFS_GRAYED        	3
#define MFS_DISABLED      	MFS_GRAYED
#define MFS_CHECKED       	MF_CHECKED
#define MFS_HILITE        	MF_HILITE
#define MFS_ENABLED       	MF_ENABLED
#define MFS_UNCHECKED     	MF_UNCHECKED
#define MFS_UNHILITE      	MF_UNHILITE
#define MFS_DEFAULT       	MF_DEFAULT


import Bool TrackPopupMenu (
    HMenu Menu,
    DWord Flags,
    DWord x,
    DWord y,
    DWord Reserved,
    HWnd Wnd,
    Pointer Reserved
    ) user32 'TrackPopupMenu';

#define MNC_IGNORE  0
#define MNC_CLOSE   1
#define MNC_EXECUTE 2
#define MNC_SELECT  3

struct TPMPARAMS {
	int    cbSize;     /* Size of structure */
	_TRect; // rcExclude;  /* Screen coordinates of rectangle to exclude when positioning */
}

import Bool TrackPopupMenuEx (
    HMenu   menu,
    int 		fuFlags,
    int 		x,
    int 		y,
    HWND 		hwnd,
    Pointer lptpm
    ) user32 'TrackPopupMenuEx';

#define MIIM_STATE       0x00000001
#define MIIM_ID          0x00000002
#define MIIM_SUBMENU     0x00000004
#define MIIM_CHECKMARKS  0x00000008
#define MIIM_TYPE        0x00000010
#define MIIM_DATA        0x00000020

#define PMenuItemInfo Pointer
struct TMenuItemInfo {
  int     cbSize;
  int     fMask;
  int     fType;          // used if MIIM_TYPE
  int     fState;         // used if MIIM_STATE
  int     wID;            // used if MIIM_ID
  HMenu   hSubMenu;       // used if MIIM_SUBMENU
  HBITMAP hbmpChecked;    // used if MIIM_CHECKMARKS
  HBITMAP hbmpUnchecked;  // used if MIIM_CHECKMARKS
  int     dwItemData;     // used if MIIM_DATA
  int     dwTypeData;     // used if MIIM_TYPE
  int     cch;            // used if MIIM_TYPE
}

import Bool InsertMenuItem (
    HMenu   HMenux ,
    int 		item,
    Bool    fByPosition,
    Pointer LPCMENUITEMINFOA
    ) user32 'InsertMenuItemA';

import Bool GetMenuItemInfo (
    HMenu   HMenux,
    int 		item,
    Bool    fByPosition,
    Pointer LPMENUITEMINFOA
    ) user32 'GetMenuItemInfoA';

import Bool SetMenuItemInfo(
    HMenu,
    int ,
    Bool,
    Pointer LPCMENUITEMINFOA
    ) user32 'SetMenuItemInfoA';

#define GMDI_USEDISABLED    0x0001
#define GMDI_GOINTOPOPUPS   0x0002

import int	GetMenuDefaultItem(
    HMenu HMenu,
    int  	fByPos,
    int  	gmdiFlags
    ) user32 'GetMenuDefaultItem';

import Bool SetMenuDefaultItem(
    HMenu HMenu,
    int  	uItem,
    int  	fByPos
    ) user32 'SetMenuDefaultItem';

import Bool GetMenuItemRect(
    HWND 		hWnd,
    HMenu   HMenu,
    int  		uItem,
    Pointer lprcItem
    ) user32 'GetMenuItemRect';

import int	MenuItemFromPoint(
    HWND 		hWnd,
    HMenu   HMenu,
    Pointer ptScreen
    ) user32 'MenuItemFromPoint';

/*
 * Flags for TrackPopupMenu
 */
#define TPM_LEFTBUTTON      0x0000
#define TPM_RIGHTBUTTON     0x0002
#define TPM_LEFTALIGN       0x0000
#define TPM_CENTERALIGN     0x0004
#define TPM_RIGHTALIGN      0x0008
#define TPM_TOPALIGN        0x0000
#define TPM_VCENTERALIGN    0x0010
#define TPM_BOTTOMALIGN     0x0020
#define TPM_HORIZONTAL      0x0000     /* Horz alignment matters more */
#define TPM_VERTICAL        0x0040     /* Vert alignment matters more */
#define TPM_NONOTIFY        0x0080     /* Don't send any notification msgs */
#define TPM_RETURNCMD       0x0100

import HMenu GetMenu(
    HWnd Wnd
    )  user32 'GetMenu';

import int   GetMenuString(
    HMenu Menu,
    DWord IDItem,
    *Asciiz Str,
    DWord MaxCount,
    DWord Flag
    )  user32 'GetMenuStringA';

import HMenu GetSubMenu(
    HMenu Menu,
    DWord Pos
    )  user32 'GetSubMenu';

import Bool  DrawMenuBar(
    HWnd Wnd
    ) user32 'DrawMenuBar';

import Bool  DestroyMenu( HMenu Menu )
		user32 'DestroyMenu';

import Bool  EnableMenuItem(
    HMenu Menu,
    DWord pos,
    DWord flags
    ) user32 'EnableMenuItem';

import Bool  CheckMenuItem(
    HMenu Menu,
    DWord IDCheckItem,
    DWord Check )
    user32 'CheckMenuItem';

import HMenu CreatePopupMenu( )
		user32 'CreatePopupMenu';

import HMenu CreateMenu( )
		user32 'CreateMenu';

import Bool  InsertMenu(
    HMenu Menu,
    DWord Position,
    DWord Flags,
    DWord IDNewItem,
    Asciiz NewItem
    ) user32 'InsertMenuA';

import Bool AppendMenu(
    HMenu Menu,
    DWord Flags,
    DWord IDNewItem,
    Asciiz NewItem
    ) user32 'AppendMenuA';

import Bool SetMenuItemBitmaps(
    HMenu Menu,
    WORD pos,
    DWord flags,
    DWord b1,
    DWord b2
    ) user32 'SetMenuItemBitmaps';


  // GetSystemMetrics( ) codes
#define SM_CXSCREEN   				0
#define SM_CYSCREEN   				1
#define SM_CXVSCROLL  				2
#define SM_CYHSCROLL  				3
#define SM_CYCAPTION  				4
#define SM_CXBORDER   				5
#define SM_CYBORDER   				6
#define SM_CXDLGFRAME 				7
#define SM_CYDLGFRAME 				8
#define SM_CYVTHUMB   				9
#define SM_CXHTHUMB   				10
#define SM_CXICON   					11
#define SM_CYICON  						12
#define SM_CXCURSOR   				13
#define SM_CYCURSOR   				14
#define SM_CYMENU   					15
#define SM_CXFULLSCREEN   		16
#define SM_CYFULLSCREEN   		17
#define SM_CYKANJIWINDOW  		18
#define SM_MOUSEPRESENT   		19
#define SM_CYVSCROLL   				20
#define SM_CXHSCROLL   				21
#define SM_DEBUG   		 				22
#define SM_SWAPBUTTON  				23
#define SM_RESERVED1   				24
#define SM_RESERVED2   				25
#define SM_RESERVED3   				26
#define SM_RESERVED4   				27
#define SM_CXMIN   		 				28
#define SM_CYMIN   		 				29
#define SM_CXSIZE  		 				30
#define SM_CYSIZE  		 				31
#define SM_CXFRAME   	 				32
#define SM_CYFRAME   	 				33
#define SM_CXMINTRACK   			34
#define SM_CYMINTRACK   			35
#define SM_CXDOUBLECLK   			36
#define SM_CYDOUBLECLK   			37
#define SM_CXICONSPACING			38
#define SM_CYICONSPACING			39
#define SM_MENUDROPALIGNMENT	40
#define SM_PENWINDOWS					41
#define SM_DBCSENABLED				42
#define SM_CMOUSEBUTTONS			43

#define SM_CXFIXEDFRAME   		SM_CXDLGFRAME // win40 name change
#define SM_CYFIXEDFRAME   		SM_CYDLGFRAME // win40 name change
#define SM_CXSIZEFRAME    		SM_CXFRAME     // win40 name change
#define SM_CYSIZEFRAME    		SM_CYFRAME     // win40 name change

#define SM_SECURE   					44
#define SM_CXEDGE   					45
#define SM_CYEDGE   					46
#define SM_CXMINSPACING   		47
#define SM_CYMINSPACING   		48
#define SM_CXSMICON   				49
#define SM_CYSMICON   				50
#define SM_CYSMCAPTION   			51
#define SM_CXSMSIZE   				52
#define SM_CYSMSIZE   				53
#define SM_CXMENUSIZE   			54
#define SM_CYMENUSIZE   			55
#define SM_ARRANGE   					56
#define SM_CXMINIMIZED				57
#define SM_CYMINIMIZED				58
#define SM_CXMAXTRACK					59
#define SM_CYMAXTRACK					60
#define SM_CXMAXIMIZED				61
#define SM_CYMAXIMIZED				62
#define SM_NETWORK						63
#define SM_CLEANBOOT					67
#define SM_CXDRAG							68
#define SM_CYDRAG							69
#define SM_SHOWSOUNDS					70
#define SM_CXMENUCHECK				71        // Use instead of GetMenuCheckMarkDimensions( )!
#define SM_CYMENUCHECK				72
#define SM_SLOWMACHINE				73
#define SM_MIDEASTENABLED			74
#define SM_MOUSEWHEELPRESENT	75
#define SM_CMETRICS						76

import DWord  GetSystemMetrics( DWord Index )
		user32 'GetSystemMetrics';

import Bool   GetClientRect( HWnd Wnd, _PRect Rect )
		user32 'GetClientRect';

import Bool   IsWindowVisible( HWnd Wnd )
		user32 'IsWindowVisible';

import HWnd	GetDesktopWindow( )
		user32 'GetDesktopWindow';

import Bool IsIconic( HWnd Wnd )
		user32 'IsIconic';

import Bool IntersectRect(
		_PRect DestRect,
		_PRect Src1Rect,
		_PRect Src2Rect
		)  user32 'IntersectRect';

import Bool IsZoomed( HWnd Wnd )
		user32 'IsZoomed';

import Bool GetCaretPos( PPoint Point )
		user32 'GetCaretPos';

import Bool HideCaret( HWnd Wnd )
		user32 'HideCaret';

import Bool ShowCaret( HWnd Wnd )
		user32 'ShowCaret';

#define PTextMetric   Pointer
struct	TTextMetric {
	int 	tmHeight;
	int 	tmAscent;
	int 	tmDescent;
	int 	tmInternalLeading;
	int 	tmExternalLeading;
	int 	tmAveCharWidth;
	int 	tmMaxCharWidth;
	int 	tmWeight;
  int		tmOverhang;
  int		tmDigitizedAspectX;
  int		tmDigitizedAspectY;
  Byte	tmFirstChar;
  Byte	tmLastChar;
  Byte	tmDefaultChar;
  Byte	tmBreakChar;
	Byte	tmItalic;
	Byte 	tmUnderlined;
	Byte 	tmStruckOut;
	Byte 	tmPitchAndFamily;
	Byte 	tmCharSet;
}

import Bool GetTextMetrics( HDC DC, PTextMetric Metrics )
		gdi32 'GetTextMetricsA';

#define PWindowPlacement Pointer
structure TWindowPlacement {
		int	Length;
		int	Flags;
		int	ShowCmd;
		//TPoint ptMinPosition;
		int PTMinPos_X;
		int PTMinPos_Y;
		//TPoint ptMaxPosition;
		int	PTMaxPos_X;
		int PTMaxPos_Y;
		//TRect rcNormalPosition;
		int RCNormPos_Left;
		int RCNormPos_Top;
		int RCNormPos_Right;
		int RCNormPos_Bottom;
}

import Bool GetWindowPlacement( HWnd Wnd, PWindowPlacement Placement )
		user32 'GetWindowPlacement';

import Bool SetWindowPlacement( HWnd Wnd, PWindowPlacement Placement )
		user32 'SetWindowPlacement';

import HMenu  GetSystemMenu( HWnd Wnd, Bool Revert )
		user32 'GetSystemMenu';

import int  GetMenuItemCount( HMenu Menu )
		user32 'GetMenuItemCount';

import int  GetMenuItemID( HMenu Menu, int Pos )
		user32 'GetMenuItemID';

import Bool ModifyMenu(
    HMenu   Menu,
		int			Position,
		int			Flags,
		int			IDNewItem,
  	Asciiz	NewItem
		) user32 'ModifyMenuA';

import Bool DeleteMenu( HMenu Menu, int Position, int Flags )
		user32 'DeleteMenu';

// MDI client style bits
#define   mdis_AllChildStyles   1

// WParam Flags for wm_MDITile and wm_MDICascade messages.
#define  mditile_Vertical       0
#define  mditILe_Horizontal     1
#define  mditile_SkipDisabled   2


#define   lf_FaceSize 32

#define PLogFont   Pointer
structure TLogFont {
	int 		lfHeight;
	int 		lfWidth;
	int 		lfEscapement;
	int 		lfOrientation;
	int 		lfWeight;
	Byte 		lfItalic;
	Byte 		lfUnderline;
	Byte 		lfStrikeOut;
	Byte 		lfCharSet;
	Byte 		lfOutPrecision;
	Byte 		lfClipPrecision;
	Byte 		lfQuality;
	Byte 		lfPitchAndFamily;
	Asciiz	lfFaceName[ lf_FaceSize ];
}

// OutPrecision values

#define   out_Default_Precis    0
#define   out_String_Precis     1
#define   out_Character_Precis  2
#define   out_Stroke_Precis     3
#define   out_TT_Precis         4
#define   out_Device_Precis     5
#define   out_Raster_Precis     6
#define   out_TT_Only_Precis    7
#define   out_Outline_Precis    8


// ClipPrecision values

#define   clip_Default_Precis   0
#define   clip_Character_Precis 1
#define   clip_Stroke_Precis    2
#define   clip_Mask             0x0F
#define   clip_LH_Angles        0x10
#define   clip_TT_Always        0x20
#define   clip_Embedded         0x80

#define   default_Quality         0
#define   draft_Quality           1
#define   proof_Quality           2
#define   nonAntiAliased_Quality  3
#define   antiAliased_Quality     4

#define   default_Pitch   0
#define   fixed_Pitch     1
#define   variable_Pitch  2
#define   mono_Font       8

#define   ansi_CharSet        0
#define   default_Charset     1
#define   symbol_CharSet      2
#define   shiftJIS_CharSet    128
#define   hangeul_Charset     129
#define   chineseBig5_Charset 136
#define   oem_CharSet         255


// Font Families

#define   ff_DontCare     0 shl 4     // Don't care or don't know.
#define   ff_Roman        1 shl 4     // Variable stroke width, serifed.
																			// times roman, century schoolbook, etc.
#define   ff_Swiss        2 shl 4     // Variable stroke width, sans-serifed.
																			// helvetica, swiss, etc.
#define   ff_Modern       3 shl 4     // Constant stroke width, serifed or sans-serifed.
																			// pica, elite, courier, etc.
#define   ff_Script       4 shl 4     // Cursive, etc.
#define   ff_Decorative   5 shl 4     // Old English, etc.


// Font Weights

#define   fw_DontCare       0
#define   fw_Thin           100
#define   fw_ExtraLight     200
#define   fw_Light          300
#define   fw_Normal         400
#define   fw_Medium         500
#define   fw_SemiBold       600
#define   fw_Bold           700
#define   fw_ExtraBold      800
#define   fw_Heavy          900

#define   fw_UltraLight     fw_ExtraLight
#define   fw_Regular        fw_Normal
#define   fw_DemiBold       fw_SemiBold
#define   fw_UltraBold      fw_ExtraBold
#define   fw_Black          fw_Heavy

import int	GetDeviceCaps( HDC DC, int Index )
		gdi32 'GetDeviceCaps';

// Device Parameters for GetDeviceCaps

#define   DriverVersion 0    // Device driver version
#define   Technology    2    // Device classification
#define   HorzSize      4    // Horizontal size in millimeters
#define   VertSize      6    // Vertical size in millimeters
#define   HorzRes       8    // Horizontal width in pixels
#define   VertRes       10   // Vertical width in pixels
#define   BitsPixel     12   // Number of bits per pixel
#define   Planes        14   // Number of planes
#define   NumBrushes    16   // Number of brushes the device has
#define   NumPens       18   // Number of pens the device has
#define   NumMarkers    20   // Number of markers the device has
#define   NumFonts      22   // Number of fonts the device has
#define   NumColors     24   // Number of colors the device supports
#define   PDeviceSize   26   // Size required for device descriptor
#define   CurveCaps     28   // Curve capabilities
#define   LineCaps      30   // Line capabilities
#define   PolygonalCaps 32   // Polygonal capabilities
#define   TextCaps      34   // Text capabilities
#define   ClipCaps      36   // Clipping capabilities
#define   RasterCaps    38   // Bitblt capabilities
#define   AspectX       40   // Length of the X leg
#define   AspectY       42   // Length of the Y leg
#define   AspectXY      44   // Length of the hypotenuse

#define   LogPixelsX    88   // Logical pixels/inch in X
#define   LogPixelsY    90   // Logical pixels/inch in Y

#define   SizePalette   104  // Number of entries in physical palette
#define   NumReserved   106  // Number of reserved entries in palette
#define   ColorRes      108  // Actual color resolution

import int	GetMessageTime( )
		user32 'GetMessageTime';

import DWord GetCurrentDirectory( DWord nBufferLength, *Asciiz lpBuffer ) kernel32 'GetCurrentDirectoryA';


// Window field offsets for GetWindowLong( )

#define  GWL_WNDPROC  		-4
#define  GWL_HINSTANCE  	-6
#define  GWL_HWNDPARENT		-8
#define  GWL_STYLE  			-16
#define  GWL_EXSTYLE  		-20
#define  GWL_USERDATA  		-21
#define  GWL_ID  					-12

  // Class field offsets for GetClassLong( )
#define  GCL_MENUNAME  	 		-8
#define  GCL_HBRBACKGROUND	-10
#define  GCL_HCURSOR  			-12
#define  GCL_HICON  				-14
#define  GCL_HMODULE  			-16
#define  GCL_CBWNDEXTRA  		-18
#define  GCL_CBCLSEXTRA  		-20
#define  GCL_WNDPROC  			-24
#define  GCL_STYLE  				-26
#define  GCW_ATOM  					-32
#define  GCL_HICONSM  			-34

import DWord GetWindowLong( HWnd Wnd, DWord Index )
		user32 'GetWindowLongA';

import int	GetWindowsDirectory( *Asciiz Buffer, int Size )
		kernel32 'GetWindowsDirectoryA';


// Commands to pass to WinHelp( ) }
#define  help_Context       1           // Display topic in ulTopic
#define  help_Quit          2           // Terminate help
#define  help_Index         3           // Display index
#define  help_Contents      3
#define  help_HelpOnHelp    4           // Display help on using help
#define  help_SetIndex      5           // Set current Index for multi index help
#define  help_SetContents   5
#define  help_ContextPopup  8
#define  help_ForceFile     9
#define  help_Key           257         // Display topic for keyword in offabData
#define  help_Command       258
#define  help_PartialKey    261
#define  help_MultiKey      513
#define  help_SetWinPos     515
#define  help_ContextMenu   10
#define  help_Finder        11
#define  help_WM_Help       12
#define  help_SetPopup_Pos  13

#define  help_TCard               0x8000
#define  help_TCard_Data          0x10
#define  help_TCard_Other_Caller  17

// These are in winhelp.h in Win95.
#define  idh_No_Help              28440
#define  idh_Missing_Context      28441  //Control doesn't have matching help context
#define  idh_Generic_Help_Button  28442  // Property sheet help button
#define  idh_Ok                   28443
#define  idh_Cancel               28444
#define  idh_Help                 28445

import Bool WinHelp(
		HWnd 		WndMain,
		Asciiz	Help,
		int			Command,
		int			Data
		)  user32 'WinHelpA';

import Bool WinHelpStr(
		HWnd		Wnd,
		Asciiz 	HelpFile,
		int			Command,
		Asciiz 	S
		)  user32 'WinHelpA';


  // 3D border styles
#define  BDR_RAISEDOUTER  1
#define  BDR_SUNKENOUTER  2
#define  BDR_RAISEDINNER  4
#define  BDR_SUNKENINNER  8

#define  BDR_OUTER  3
#define  BDR_INNER  12
#define  BDR_RAISED  5
#define  BDR_SUNKEN  10

#define  EDGE_RAISED  ( BDR_RAISEDOUTER or BDR_RAISEDINNER )
#define  EDGE_SUNKEN  ( BDR_SUNKENOUTER or BDR_SUNKENINNER )
#define  EDGE_ETCHED  ( BDR_SUNKENOUTER or BDR_RAISEDINNER )
#define  EDGE_BUMP  ( BDR_RAISEDOUTER or BDR_SUNKENINNER )

  // Border flags
#define  BF_LEFT  1
#define  BF_TOP  2
#define  BF_RIGHT  4
#define  BF_BOTTOM  8

#define  BF_TOPLEFT  ( BF_TOP or BF_LEFT )
#define  BF_TOPRIGHT  ( BF_TOP or BF_RIGHT )
#define  BF_BOTTOMLEFT  ( BF_BOTTOM or BF_LEFT )
#define  BF_BOTTOMRIGHT  ( BF_BOTTOM or BF_RIGHT )
#define  BF_RECT  ( BF_LEFT or BF_TOP or BF_RIGHT or BF_BOTTOM )

#define  BF_DIAGONAL  0x10

  // For diagonal lines, the BF_RECT flags specify the end point of the
  // vector bounded by the rectangle parameter.
#define  BF_DIAGONAL_ENDTOPRIGHT  ( BF_DIAGONAL or BF_TOP or BF_RIGHT )
#define  BF_DIAGONAL_ENDTOPLEFT  ( BF_DIAGONAL or BF_TOP or BF_LEFT )
#define  BF_DIAGONAL_ENDBOTTOMLEFT  ( BF_DIAGONAL or BF_BOTTOM or BF_LEFT )
#define  BF_DIAGONAL_ENDBOTTOMRIGHT  ( BF_DIAGONAL or BF_BOTTOM or BF_RIGHT )

#define  BF_MIDDLE  0x800   //{ Fill in the middle }
#define  BF_SOFT  0x1000    //{ For softer buttons }
#define  BF_ADJUST  0x2000  //{ Calculate the space left over }
#define  BF_FLAT  0x4000    //{ For flat rather than 3D borders }
#define  BF_MONO  0x8000    //{ For monochrome borders }

import Bool DrawEdge( DWord hdc, Pointer qrc, DWord edge, DWord grfFlags )
    user32 'DrawEdge';


#define infinite    0xFFFFFFFF          // Infinite timeout

#define status_Wait_0             0x00000000
#define status_Abandoned_Wait_0   0x00000080
#define status_Timeout            0x00000102

#define wait_Failed     0xFFFFFFFF
#define wait_Object_0   status_Wait_0
#define wait_Abandoned  status_Abandoned_Wait_0
#define wait_Timeout    status_Timeout

import int WaitForInputIdle(
		int HProcess,
		int Milliseconds
		) user32 'WaitForInputIdle';

import int WaitForSingleObject(
		int	HHandle,
		int	Milliseconds
		) kernel32 'WaitForSingleObject';

import int	GetDialogBaseUnits( )
		user32 'GetDialogBaseUnits';

import int	SetErrorMode( int Mode )
		kernel32 'SetErrorMode';

import int  GetLogicalDrives( )
    kernel32 'GetLogicalDrives';

import Bool SetForegroundWindow( HWnd Wnd )
		user32 'SetForegroundWindow';

import int  GetKeyNameText(
    int     LParam,
    *Asciiz String,
    int     Size
    ) user32 'GetKeyNameTextA';


#define POsVersionInfo  Pointer
structure TOsVersionInfo {
	int			OsVersionInfoSize;
  int 		MajorVersion;
  int 		MinorVersion;
  int 		BuildNumber;
  int 		PlatformId;
	Asciiz	szCSDVersion[ 128 ]; 					// Maintenance string for PSS usage
}

// dwPlatformId defines
#define   ver_platform_Win32S         0
#define   ver_platform_Win32_Windows  1
#define   ver_platform_Win32_Nt       2

import Bool GetVersionEx( POsVersionInfo VersionInfo )
		kernel32 'GetVersionExA';

import DWord GetTickCount( )
		kernel32 'GetTickCount';

// Registry access
structure _Reg_Temp {
  Asciiz  T1[ 260 ];
  int     I1;
}

#define   READ_CONTROL              0x00020000
#define   STANDARD_RIGHTS_READ      READ_CONTROL
#define   STANDARD_RIGHTS_WRITE     READ_CONTROL
#define   STANDARD_RIGHTS_EXECUTE   READ_CONTROL
#define   STANDARD_RIGHTS_ALL       0x001F0000
#define   SPECIFIC_RIGHTS_ALL       00x0000FFFF
#define   ACCESS_SYSTEM_SECURITY    0x01000000

#define   HKEY_CLASSES_ROOT     0x80000000
#define   HKEY_CURRENT_USER     0x80000001
#define   HKEY_LOCAL_MACHINE    0x80000002
#define   HKEY_USERS            0x80000003
#define   HKEY_PERFORMANCE_DATA 0x80000004
#define   HKEY_CURRENT_CONFIG   0x80000005
#define   HKEY_DYN_DATA         0x80000006

// Registry Specific Access Rights.

#define  KEY_QUERY_VALUE     0x0001
#define  KEY_SET_VALUE       0x0002
#define  KEY_CREATE_SUB_KEY  0x0004
#define  KEY_ENUMERATE_SUB_KEYS  0x0008
#define  KEY_NOTIFY          0x0010
#define  KEY_CREATE_LINK     0x0020

#define  SYNCHRONIZE 0x00100000

#define  KEY_READ            ( STANDARD_RIGHTS_READ | KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS | KEY_NOTIFY ) & (-1 ^ ( SYNCHRONIZE ))



#define  KEY_WRITE           ( STANDARD_RIGHTS_WRITE | KEY_SET_VALUE | KEY_CREATE_SUB_KEY ) & (-1 ^ ( SYNCHRONIZE ))

#define  KEY_EXECUTE          KEY_READ & (-1 ^ ( SYNCHRONIZE ))


#define  KEY_ALL_ACCESS      ( ( STANDARD_RIGHTS_ALL | KEY_QUERY_VALUE | KEY_SET_VALUE | KEY_CREATE_SUB_KEY | KEY_ENUMERATE_SUB_KEYS | KEY_NOTIFY | KEY_CREATE_LINK ) & (-1 ^ ( SYNCHRONIZE )) )

#define  // Registry Open/Create Options

#define  REG_OPTION_RESERVED      ( 0x00000000 )    // Parameter is reserved

#define  REG_OPTION_NON_VOLATILE  ( 0x00000000 )    // Key is preserved
                                                 // when system is rebooted

#define  REG_OPTION_VOLATILE      ( 0x00000001 )    // Key is not preserved
                                                 // when system is rebooted

#define  REG_OPTION_CREATE_LINK   ( 0x00000002 )    // Created key is a
                                                 // symbolic link

#define  REG_OPTION_BACKUP_RESTORE  ( 0x00000004 )  // open for backup | restore
                                                 // special access rules
                                                 // privilege required

#define  REG_LEGAL_OPTION   ( REG_OPTION_RESERVED | REG_OPTION_NON_VOLATILE | REG_OPTION_VOLATILE | REG_OPTION_CREATE_LINK | REG_OPTION_BACKUP_RESTORE )

// Registry Key creation/open disposition

#define  REG_CREATED_NEW_KEY      ( 0x00000001 )    // New Registry Key created
#define  REG_OPENED_EXISTING_KEY  ( 0x00000002 )    // Existing Key opened

// Registry Key restore flags

#define  REG_WHOLE_HIVE_VOLATILE  ( 0x00000001 )    // Restore whole hive volatile
#define  REG_REFRESH_HIVE         ( 0x00000002 )    // Unwind changes to last flush

// Registry Notify filter values

#define  REG_NOTIFY_CHANGE_NAME        ( 0x00000001 ) // Create | delete ( child )
#define  REG_NOTIFY_CHANGE_ATTRIBUTES  ( 0x00000002 )
#define  REG_NOTIFY_CHANGE_LAST_SET    ( 0x00000004 ) // time stamp
#define  REG_NOTIFY_CHANGE_SECURITY    ( 0x00000008 )

#define  REG_LEGAL_CHANGE_FILTER  ( REG_OPTION_RESERVED | REG_NOTIFY_CHANGE_NAME | REG_NOTIFY_CHANGE_ATTRIBUTES |REG_NOTIFY_CHANGE_LAST_SET |REG_NOTIFY_CHANGE_SECURITY )

// Registry Predefined Value Types

#define  REG_NONE                     0
#define  REG_SZ                       1
#define  REG_EXPAND_SZ                2
#define  REG_BINARY                   3
#define  REG_DWord                    4
#define  REG_DWord_LITTLE_ENDIAN      4
#define  REG_DWord_BIG_ENDIAN         5
#define  REG_LINK                     6
#define  REG_MULTI_SZ                 7
#define  REG_RESOURCE_LIST            8
#define  REG_FULL_RESOURCE_DESCRIPTOR  9
#define  REG_RESOURCE_REQUIREMENTS_LIST  10

import DWord RegCloseKey( DWord Key )
		advapi32 'RegCloseKey';

import DWord RegConnectRegistry(
		Asciiz 	lpMachineName,
		DWord 	Key
		*DWord	phkResult
		) advapi32 'RegConnectRegistryA';

import DWord RegCreateKey(
		DWord		Key,
		Asciiz 	lpSubKey,
  	*DWord 	phkResul
		) advapi32 'RegCreateKeyA';

import DWord RegCreateKeyEx(
		DWord 	Key,
		Asciiz 	lpSubKey,
  	DWord 	Reserved,
		Asciiz 	lpClass,
		DWord 	dwOptions,
		DWord 	samDesired,
  	Pointer lpSecurityAttributes,
		*DWord 	HKey,
  	*DWord 	lpdwDisposition
		) advapi32 'RegCreateKeyExA';

import DWord RegDeleteKey( DWord Key, Asciiz 	lpSubKey )
		advapi32 'RegDeleteKeyA';

import DWord RegDeleteValue( DWord Key, Asciiz lpValueName )
		advapi32 'RegDeleteValueA';

import DWord RegEnumKey(
		DWord 	Key,
		DWord 	dwIndex,
		Asciiz 	lpName,
		DWord 	cbName
		) advapi32 'RegEnumKeyA';

import DWord RegEnumKeyEx(
		DWord 	Key,
		DWord 	dwIndex,
		Asciiz 	lpName,
  	*DWord 	lpcbName,
		Pointer lpReserved,
		Asciiz 	lpClass,
  	Pointer lpcbClass,
		Pointer lpftLastWriteTime
		) advapi32 'RegEnumKeyExA';

import DWord RegEnumValue(
		DWord 	Key,
		DWord 	dwIndex,
		Asciiz 	lpValueName,
  	*DWord 	lpcbValueName,
		Pointer lpReserved,
		Pointer lpType,
  	Pointer lpData,
		Pointer lpcbData
		) advapi32 'RegEnumValueA';

import DWord RegFlushKey( DWord Key )
		advapi32 'RegFlushKey';

import DWord RegGetKeySecurity(
		DWord 	Key,
		DWord 	SecurityInformation,
  	Pointer pSecurityDescriptor,
		*DWord 	lpcbSecurityDescriptor
		) advapi32 'RegGetKeySecurity';

import DWord RegLoadKey( DWord Key, Asciiz lpSubKey, Asciiz lpFile )
		advapi32 'RegLoadKeyA';

import DWord RegNotifyChangeKeyValue(
		DWord 	Key,
		DWord 	bWatchSubtree,
  	DWord 	dwNotifyFilter,
		DWord 	hEvent,
		DWord 	fAsynchronus
		) advapi32 'RegNotifyChangeKeyValue';

import DWord RegOpenKey( DWord Key, Asciiz lpSubKey, *DWord phkResult )
		advapi32 'RegOpenKeyA';

import DWord RegOpenKeyEx(
		DWord 	Key,
		Asciiz 	lpSubKey,
  	DWord 	ulOptions,
		DWord 	samDesired,
		*DWord 	phkResult
		) advapi32 'RegOpenKeyExA';

import DWord RegQueryInfoKey(
		DWord 	Key,
		Asciiz 	lpClass,
  	Pointer lpcbClass,
		Pointer lpReserved,
  	Pointer lpcSubKeys,
		Pointer lpcbMaxSubKeyLen,
		Pointer lpcbMaxClassLen,
		Pointer lpcValues,
  	Pointer lpcbMaxValueNameLen,
		Pointer lpcbMaxValueLen,
		Pointer lpcbSecurityDescriptor,
  	Pointer lpftLastWriteTime
		) advapi32 'RegQueryInfoKeyA';

import DWord RegQueryValue(
		DWord 	Key,
		Asciiz 	lpSubKey,
  	Asciiz 	lpValue,
		*DWord 	lpcbValue
		) advapi32 'RegQueryValueA';

import DWord RegQueryMultipleValues(
		DWord 	Key,
		Pointer ValList,
  	DWord 	NumVals,
		Asciiz 	lpValueBuf,
		*DWord 	ldwTotsize
		) advapi32 'RegQueryMultipleValuesA';

import DWord RegQueryValueEx(
		DWord 	Key,
		Asciiz 	lpValueName,
  	Pointer lpReserved,
		Pointer lpType,
		Pointer lpData,
		Pointer lpcbData
		) advapi32 'RegQueryValueExA';

import DWord RegReplaceKey(
		DWord		Key,
		Asciiz 	lpSubKey,
   	Asciiz 	lpNewFile,
		Asciiz 	lpOldFile
		) advapi32 'RegReplaceKeyA';

import DWord RegRestoreKey(
		DWord	 Key,
		Asciiz lpFile,
		DWord 	dwFlags
		) advapi32 'RegRestoreKeyA';

import DWord RegSaveKey(
		DWord 	Key,
		Asciiz 	lpFile,
  	Pointer lpSecurityAttributes
		) advapi32 'RegSaveKeyA';

import DWord RegSetKeySecurity(
		DWord 	Key,
		DWord 	SecurityInformation,
  	Pointer pSecurityDescriptor
		) advapi32 'RegSetKeySecurity';

import DWord RegSetValue(
		DWord 	Key,
		Asciiz 	lpSubKey,
  	DWord 	dwType,
		Asciiz 	lpData,
		DWord 	cbData
		) advapi32 'RegSetValueA';

import DWord RegSetValueEx(
		DWord 	Key,
		Asciiz 	lpValueName,
  	DWord 	Reserved,
		DWord 	dwType,
		Pointer	lpData,
		DWord 	cbData
		) advapi32 'RegSetValueExA';

import DWord RegUnLoadKey( DWord Key, Asciiz lpSubKey )
		advapi32 'RegUnLoadKeyA';

import Bool LockWindowUpdate( HWnd Wnd )
    user32 'LockWindowUpdate';

import void OutputDebugString( Asciiz lpOutputString )
		kernel32 'OutputDebugStringA';

import int GetEnvironmentVariable(
    Asciiz    Name,
    *Asciiz   Buffer,
    int       Size
    ) kernel32 'GetEnvironmentVariableA';


#define ATOM  Word

import ATOM GlobalAddAtom( *Asciiz lpString )
    kernel32 'GlobalAddAtomA';

import ATOM GlobalDeleteAtom( ATOM nAtom )
    kernel32 'GlobalDeleteAtom';


#define PSystemTime Pointer
struct TSystemTime {
  Word  wYear;
  Word  wMonth;
  Word  wDayOfWeek;
  Word  wDay;
  Word  wHour;
  Word  wMinute;
  Word  wSecond;
  Word  wMilliseconds;
}

import void GetSystemTime( PSystemTime St )
    kernel32 'GetSystemTime';

import int  GetDateFormat(
    int     Local,
    int     dwFlags,
    Pointer lpDate,
    Asciiz  lpFormat,
    *Asciiz lpDateStr,
    int     cchDate
    )  kernel32 'GetDateFormatA';

import int  GetTimeFormat(
    int     Local,
    int     dwFlags,
    Pointer lpTime,
    Asciiz  lpFormat,
    *Asciiz lpTimeStr,
    int     cchTime
    )  kernel32 'GetTimeFormatA';