// $Header: /MeWin32/SH/window.sh 9     6/09/98 10:35p Dan $

#define WNOP_CREATE     0
#define WNOP_DELETE     1
#define WNOP_HIDE       2
#define WNOP_LIST       3
#define WNOP_SPLIT      4
#define WNOP_LINK       6
#define WNOP_UNLINK     7
#define WNOP_ZOOM       8
#define WNOP_DELETEALL  9
#define WNOP_MINIMIZE   10
#define WNOP_MAXIMIZE   11

#define WGOP_CASCADE    0
#define WGOP_TILEVERT   1
#define WGOP_MINALL     2
#define WGOP_TILEHORZ   3

// SplitWinDlg control constants
#define id_adj_Up				1401
#define id_adj_Down     1402
#define id_adj_Left			1403
#define id_adj_Right		1404


global {
	int g_hAdjacentDlg 	"!H_ADJACENT_DLG";
	int g_hAdjacentUp 	"!H_ADJACENT_UP";
	int g_hAdjacentDn 	"!H_ADJACENT_DN";
	int g_hAdjacentLf 	"!H_ADJACENT_LF";
	int g_hAdjacentRt 	"!H_ADJACENT_RT";
  int g_CWResize      "!CWResize";
  int g_NoCWResize    "#NoCWResize";
}


#define _max_Splits 	50

struct TWinSplits {
	int Count;
	int WinIds[ _max_Splits ];
	int Resize[ _max_Splits ];
	int Edge[ _max_Splits ];
	int NewPos[ _max_Splits ];
}

// UnSplitWin flag constants
#define _usw_flag_DelWin		0x00000001

#define _usr_None						0x00
#define _usr_Left						0x01
#define _usr_Right					0x02
#define _usr_Up							0x04
#define _usr_Down						0x08

#define _usr_LeftRight			0x03
#define _usr_UpDown					0x0C

prototype Window {
	void  WinMenu( int Parent );
	void  CreateNoFileWin( );
	void  MakeWin( );
	int   DelWin( int No_Del, int MR, int BC );
	void  SplitWin( int SSize, str Dir, int Win2_Id );
	void  LinkWin( );
	void  Win_Icon_Arrange( );
	void  Minimize( );
	void  Maximize( );
	void  Zoom( );
	void  Worganize( int Op );
	void  WinOp( int Op );

	int  SplitWinDlg( str Title, int Enables );
	int UnSplitWin( int Win2Id, str Direction, int Flags );
	void SortWindows( int WinSort );
/******************************************************************************
	Function: Sort windows based upon the WinSort global variable.  Can sort
						by Filename, Path or Extension.

	Entry		: int WinSort			- Flag to override the "Auto sort windows setting
															in configure.  														( /S= )
							_ws_Off					- Use "Auto sort windows" setting from configure
							_ws_File				- Sort by filename
							_ws_Path				- Sort by path
							_ws_Ext					- Sort by extension
*******************************************************************( ldh )***/
	void SWinSelect( int NextWin, str Params );
	void SWinSet( );
	int GetWinSplits( struct TWinSplits );
	int SWinSetNextWin( );
  void SWinReset( );
}
