#DEFINE _wl_GC_REGET_END  0x0001
#define _wl_GC_NOGETPARMS 0x0002
#define _wl_GC_NOMARK     0x0004

#define _WL_QUOTED        0x0001
#define _WL_TOGGLE        0x0002

#define _WL_HASATTRIBS    0x0001
#define _WL_HASMATCH      0x0002

#define _WL_ATTRIBNAME    "WL_CNTXTEDIT_";


#define _WL_ATTR_TEXT       1
#define _WL_ATTR_INTEGER    2
#define _WL_ATTR_CHOICE     3
#define _WL_ATTR_FILE       4
#define _WL_ATTR_FONT       5
#define _WL_ATTR_FONTSIZE   6
#define _WL_ATTR_IPERCENT   7
#define _WL_ATTR_URL        8
#define _WL_ATTR_COLOR      9
#define _WL_ATTR_GRAPHIC    10
#define _WL_ATTR_SEPERATOR  11


#define _wl_FM_Tag_MatchReq       0x00000001
#define _wl_FM_Tag_MatchOpt       0x00000002
#define _wl_FM_Tag_Indent         0x00000004
#define _wl_FM_Tag_NewLevel       0x00000008
#define _wl_FM_Tag_Eol            0x00000010
#define _wl_FM_Tag_Bol            0x00000020
#define _wl_FM_Tag_BL_Eol         0x00000040
#define _wl_FM_Tag_BL_Bol         0x00000080
#define _wl_FM_Tag_IndentIgn      0x00000100
#define _wl_FM_Tag_EndPar         0x00000200
#define _wl_FM_Tag_IndentDisable  0x00000400
#define _wl_FM_Tag_NoStyle        0x00000800

#define _wl_FM_xTag_Eol           0x00010000
#define _wl_FM_xTag_Bol           0x00020000
#define _wl_FM_xTag_BL_Eol        0x00040000
#define _wl_FM_xTag_BL_Bol        0x00080000
#define _wl_FM_xTag_EndPar        0x00100000


global
{
  int g_wl_HtmlContext_Count "!g_wl_HtmlContext_Count";
}

structure _wl_HtmlContext
{
  str tag_name[40];
  int start_line;
  int start_col;
  int end_line;
  int end_col;
  int flags;

  int tag_flags;

  int attribcount;
  str attribname[32];
  int attribwidth;
}

prototype wlparse
{
  void wl_SkipBlankSpace();

  int wl_GetHtmlContext( struct _wl_HtmlContext, int flags );
  /********************************************************************
                                                      Multi-Edit Macro
                                                        5/28/96 3:37PM

    Function: Fills a context structure with information about the
              current html tag

    Entry   : flags   _wl_GC_REGET_END  re-finds the end point

    Exit    : true  if a complete html context was retrieved

    NOTE:   wl_ReleaseHtmlContext must be called after you are done
    with processing the html context.
  ********************************************************************/

  void wl_ReleaseHtmlContext( struct _wl_HtmlContext );


  int wl_FindHtmlContextValue( struct _wl_HtmlContext,
                              str name
                              );
  /********************************************************************
                                                      Multi-Edit Macro
                                                        5/29/96 9:37AM
    Function: Finds a context value
    Exit    : Returns true if the value existed
  ********************************************************************/

  str wl_ParseHtmlContextValue( struct _wl_HtmlContext );
  /********************************************************************
                                Multi-Edit Macro
                                5/29/96 9:51AM

    Function: Parses the value under the cursor
    Exit    : returns the string
  ********************************************************************/

  int wl_GetHtmlContextValue( struct _wl_HtmlContext, str name, str &value );
  /********************************************************************
                                                      5/29/96 10:47PM

    Function: Retrieve the specified value
  ********************************************************************/


  void wl_RemoveHtmlContextValue( struct _wl_HtmlContext, str name );
  /********************************************************************
                                Multi-Edit Macro
                                5/29/96 12:59PM

    Function: Deletes a context value
  ********************************************************************/

  void wl_SetHtmlContextValue( struct _wl_HtmlContext, str name, str v, int flags  );
  /********************************************************************
                                Multi-Edit Macro
                                5/29/96 12:59PM

    Function: Sets a context value

              flags =  _WL_QUOTED enter value in quotes

  ********************************************************************/

  int wl_ParseIntValue( str tstr );
}
